package com.weaver.seconddev.jcldoor.cmd;

import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 开发人员问题支持数量
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/14
 */
@Component
public class DevQuestCountCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(DevQuestCountCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    public String tenant_key = "t7akvdnf84";

    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        log.error("DevQuestCountCmd");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

        String groupId = "weaver-workflow-report-serviceworkflowreport";
        String sourceType = "LOGIC";


        Map<String, Object> dataMap = new HashMap<String, Object>();
        String devcou = "0";
        try {
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");
            String employeeId = request.getParameter("employeeId");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if (StringUtils.isBlank(startday)) {
                startday = year + "-01-01";
            }
            if (StringUtils.isBlank(endday)) {
                endday = sdf.format(new Date());
            }

            if (StringUtils.isBlank(employeeId)) {
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            if (StringUtils.isNotBlank(employeeId)) {
                String dataSql = " select ifnull(sum(d.integer2),0) as devcou \n" +
                        " from wfc_form_data l\n" +
                        " inner join fto_62 d on d.id = l.dataid\n" +
                        " inner join wfc_requestbase p on p.requestid = l.requestid\n" +
                        " where d.multiresource5='" + employeeId + "'\n" +
                        " and d.date2 >='" + startday + "'" +
                        " and d.date2 <='" + endday + "'" +
                        " and d.tenant_key='" + tenant_key + "'\n" +
                        " and d.is_delete='0'\n" +
                        " and l.tenant_key='" + tenant_key + "'\n" +
                        " and l.delete_type=0\n" +
                        " and p.tenant_key='" + tenant_key + "'\n" +
                        " and p.delete_type=0\n" +
                        " order by d.id desc ";

                log.info("DevQuestCountCmd dataSql:" + dataSql);

                Map<String, Object> result = databaseUtils.execute(sourceType, groupId, dataSql);
                List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(result);
                if (CollectionUtils.isNotEmpty(recordList)) {
                    devcou = String.valueOf(recordList.get(0).get("devcou"));
                }
            }
            dataMap.put("count", devcou);
        } catch (Exception e) {
            log.error("DevQuestCountCmd-Exception:" + e.getMessage());
        }
        return dataMap;
    }
}
