package com.weaver.seconddev.jcldoor.cmd;

import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 本年日报微博数量
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/13
 */
@Component
public class PortalDailyCountCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(PortalDailyCountCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    public String tenant_key = "t7akvdnf84" ;

    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        log.error("PortalDailyCountCmd");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

        String groupId = "weaver-blog-service";
        String sourceType = "LOGIC";


        Map<String,Object> dataMap = new HashMap<String,Object>();
        try{
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");
            String employeeId = request.getParameter("employeeId");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            String sql =" select count(1) as count\n" +
                    "    from blog " +
                    "    where creator='"+employeeId+"'\n" +
                    "    and left(BLOG_TIME,10) >='"+startday+"'\n" +
                    "    and left(BLOG_TIME,10) <='"+endday+"'\n" +
                    "    and type='blog'\n" +
                    "    and TENANT_KEY = '"+tenant_key+"'\n" +
                    "    and MODULE = 'blog'\n" +
                    "    and DELETE_TYPE = 0\n" +
                    "    and CONTENT is not null" ;

            log.error("PortalDailyCountCmd sql:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(recordList.size()>0){
                dataMap = recordList.get(0);
            }
        }catch (Exception e){
            log.error("PortalDailyCountCmd-Exception:"+e.getMessage());
            dataMap.put("count",0);
        }
        return dataMap;
    }
}
