package com.weaver.seconddev.jcldoor.cmd;

import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 本年文档创建贡献数
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/13
 */
@Component
public class PortalDocCreateCountCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(PortalDocCreateCountCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    public String tenant_key = "t7akvdnf84" ;

    /**
     * 本年文档创建贡献数
     * @param simpleEmployee
     * @return
     */
    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        log.error("PortalDocCreateCountCmd");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

        String groupId = "weaver-doc-service";
        String sourceType = "LOGIC";


        Map<String,Object> dataMap = new HashMap<String,Object>();
        try{
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");
            String employeeId = request.getParameter("employeeId");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            String sql = " select count(1) as count from document " +
                    " where CREATOR='"+employeeId+"'\n" +
                    " and left(create_time,10)>='"+startday+"' and left(create_time,10) <= '"+endday+"'" ;

            log.error("PortalDocCreateCountCmd sql:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(recordList.size()>0){
                dataMap = recordList.get(0);
            }

        }catch (Exception e){
            log.error("PortalDocCreateCountCmd-Exception:"+e.getMessage());
            dataMap.put("count",0);
        }
        return dataMap;
    }
}
