package com.weaver.seconddev.jcldoor.cmd;

import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import java.time.LocalDate;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 风险信息
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/8
 */
@Component
public class PortalRiskInfoCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(PortalRiskInfoCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    public String tenant_key = "t7akvdnf84" ;


    /**
     * 获取风险信息
     * @param simpleEmployee
     * @return
     */
    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> recordMap = new HashMap<String,Object>();
        try {

            String day = null2String(request.getParameter("day"),"30");
            SimpleEmployee employee = UserContext.getCurrentUser();

            String startDay = "";
            log.error("PortalRiskInfoCmd day:"+startDay);
            if(StringUtils.isNotBlank(day)){
                int day_ = Integer.parseInt(day);
                LocalDate today = LocalDate.now(); // 获取当前日期
                LocalDate tenDaysBefore = today.minusDays(day_); // 当前日期前10天
                startDay = tenDaysBefore.toString();
            }else{
                LocalDate today = LocalDate.now(); // 获取当前日期
                LocalDate tenDaysBefore = today.minusDays(30); // 当前日期前10天
                startDay = tenDaysBefore.toString();
            }

            log.error("PortalRiskInfoCmd startDay:"+startDay);

            long employeeId = UserContext.getCurrentEmployeeId();


            String groupId = "weaver-portrait-service";
            String sourceType = "LOGIC";

            String sql ="  SELECT \n" +
                    "  t1.id typeid,\n" +
                    "  t1.name typename,\n" +
                    "  t2.id riskid,\n" +
                    "  t2.name riskname,\n" +
                    "  t.risk_value,\n" +
                    "  e.username,\n" +
                    "  t.tenant_key,\n" +
                    "  t.userid,\n" +
                    "  times \n" +
                    "  FROM ( \n" +
                    "        SELECT k.riskid,k.risk_value,k.tenant_key,k.userid,COUNT(k.riskid) times  \n" +
                    "        FROM (\n" +
                    "            SELECT t.riskid,t.risk_value,t.tenant_key,t.userid\n" +
                    "            FROM pr_indrisk_data t \n" +
                    "            WHERE t.delete_type = 0 \n" +
                    "            AND t.tenant_key = '"+tenant_key+"'\n" +
                    "            AND t.risk_date >= '"+startDay+"'\n" +
                    "            AND  t.userid = '"+employeeId+"'\n" +
                    "            union all\n" +
                    "            SELECT t.riskid,t.risk_value,t.tenant_key,t.userid \n" +
                    "            FROM pr_indrisk_data t \n" +
                    "            WHERE t.delete_type = 0 \n" +
                    "            AND t.tenant_key = '"+tenant_key+"' \n" +
                    "            AND t.risk_date >= '"+startDay+"' \n" +
                    "            AND t.userid IN (select cid from eteams.emp_link where pid= '"+employeeId+"' and relation = 'senior') \n" +
                    "        ) k \n" +
                    "        GROUP BY k.riskid,\n" +
                    "        k.risk_value,\n" +
                    "        k.tenant_key,\n" +
                    "        k.userid\n" +
                    "    ) t,\n" +
                    "    pr_indrisk_type t1,\n" +
                    "    pr_indrisk_info t2 ,\n" +
                    "    eteams.employee e\n" +
                    "    WHERE t.riskid = t2.id \n" +
                    "    AND t2.risk_type = t1.id \n" +
                    "    AND t.userid = e.id\n" +
                    "    AND e.STATUS != 'unavailable' AND e.PERMANENTLY_DELETE = '0'\n" +
                    "    AND t1.delete_type = 0 \n" +
                    "    AND t2.delete_type = 0" ;

            log.error("PortalRiskInfoCmd:"+sql);

            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            for(int i=0;i<recordList.size();i++){
                Map<String,Object>  recordMap2 = recordList.get(i);
                recordMap2.put("pid",i+"");
            }
            recordMap.put("datas",recordList);
        } catch (Exception e) {
            e.printStackTrace();
            log.error("PortalRiskInfoCmd E:"+e);
        }
        return recordMap;
    }

    public static String null2String(String s,String def) {
        return s == null ?(def==null?"":def) : s;
    }
}
