package com.weaver.seconddev.jcldoor.cmd;

import com.alibaba.fastjson.JSONObject;
import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import okhttp3.*;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * 人员工作成就
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/4
 */
@Component
public class PortalWorkAchievementCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(UserInfoCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    /**
     * 获取工作成就信息
     * @param simpleEmployee
     * @return
     */
    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String, Object> result = getSaleInfo(request,simpleEmployee);

        return result;
    }

    public Map<String,Object> getSaleInfo(HttpServletRequest request, SimpleEmployee simpleEmployee){
        Map<String,Object> map = new HashMap<>(10);
        String headcookie = request.getHeader("Cookie");
        //有效合同金额
        JSONObject yxhtjeObj = new JSONObject();
        try {
            JSONObject params = new JSONObject();
            params.put("compId","e12a1c232bbe4238859da5963f5e9407");
            params.put("pageId","880065951867256872");
            params.put("filter","[{\"value\":\"f26759ae44ef4e2f866b8dc3359b8c8a\",\"conditionComId\":\"d84ed5ccd4204ef595885cad8dde1822\",\"funcType\":\"\",\"filterFields\":[],\"dataType\":\"classification\",\"conditionType\":\"and\"}]");
            params.put("pageFilter","[{\"dataset\":{\"id\":\"10\",\"text\":\"业绩达成表\",\"type\":\"LOGIC\",\"groupId\":\"weaver-ebuilder-contract-servicecmdatauFJXHS\",\"isPhysical\":false}}]");
            params.put("cusMenuId","838181366272991264");
            params.put("urlPageTitle","5ZCI5ZCM6Zeo5oi3");

            OkHttpClient client = new OkHttpClient().newBuilder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, params.toJSONString());
            Request requestPost = new Request.Builder()
                    .url("http://10.12.253.23:20600/api/ebuilder/coms/digitalpanel/getData")
                    .method("POST", body)
                    .addHeader("Cookie", headcookie)
                    .addHeader("Content-Type", "application/json")
                    .build();
            Response response  = client.newCall(requestPost).execute();

            int code = response.code();
            log.error("getSaleInfo yxhtjeObj:"+code);
            String data = response.body().string();

            log.error("getSaleInfo yxhtjeObj:"+data);

            if(StringUtils.isNotBlank(data)){
                yxhtjeObj = JSONObject.parseObject(data);
            }
        } catch (IOException e) {
            e.printStackTrace();
            log.error("getSaleInfo yxhtjeObj:"+e);
        }
        map.put("yxhtjeObj",yxhtjeObj);


        //新客户销售合同金额
        JSONObject xkhxshtjeObj = new JSONObject();
        try {
            JSONObject params = new JSONObject();
            params.put("compId","c0a6f30332a04612b17487f894a9bdb2");
            params.put("pageId","880065951867256872");
            params.put("filter","[{\"value\":\"f26759ae44ef4e2f866b8dc3359b8c8a\",\"conditionComId\":\"d84ed5ccd4204ef595885cad8dde1822\",\"funcType\":\"\",\"filterFields\":[],\"dataType\":\"classification\",\"conditionType\":\"and\"}]");
            params.put("pageFilter","[{\"dataset\":{\"id\":\"40\",\"text\":\"类型分布表\",\"type\":\"LOGIC\",\"groupId\":\"weaver-ebuilder-contract-servicecmdatauFJXHS\",\"isPhysical\":false}}]");
            params.put("cusMenuId","838181366272991264");
            params.put("urlPageTitle","5ZCI5ZCM6Zeo5oi3");

            OkHttpClient client = new OkHttpClient().newBuilder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, params.toJSONString());
            Request requestPost = new Request.Builder()
                    .url("http://10.12.253.23:20600/api/ebuilder/coms/digitalpanel/getData")
                    .method("POST", body)
                    .addHeader("Cookie", headcookie)
                    .addHeader("Content-Type", "application/json")
                    .build();
            Response response  = client.newCall(requestPost).execute();

            int code = response.code();
            log.error("getSaleInfo xkhxshtjeObj:"+code);
            String data = response.body().string();

            log.error("getSaleInfo xkhxshtjeObj:"+data);

            if(StringUtils.isNotBlank(data)){
                xkhxshtjeObj = JSONObject.parseObject(data);
            }
        } catch (IOException e) {
            e.printStackTrace();
            log.error("getSaleInfo xkhxshtjeObj:"+e);
        }
        map.put("xkhxshtjeObj",xkhxshtjeObj);


        //老客户销售合同金额
        JSONObject lkhxshtjeObj = new JSONObject();
        try {
            JSONObject params = new JSONObject();
            params.put("compId","eed91abb469f49928ef2a7a89ab02c93");
            params.put("pageId","880065951867256872");
            params.put("filter","[{\"value\":\"f26759ae44ef4e2f866b8dc3359b8c8a\",\"conditionComId\":\"d84ed5ccd4204ef595885cad8dde1822\",\"funcType\":\"\",\"filterFields\":[],\"dataType\":\"classification\",\"conditionType\":\"and\"}]");
            params.put("pageFilter","[{\"dataset\":{\"id\":\"40\",\"text\":\"类型分布表\",\"type\":\"LOGIC\",\"groupId\":\"weaver-ebuilder-contract-servicecmdatauFJXHS\",\"isPhysical\":false}}]");
            params.put("cusMenuId","838181366272991264");
            params.put("urlPageTitle","5ZCI5ZCM6Zeo5oi3");

            OkHttpClient client = new OkHttpClient().newBuilder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, params.toJSONString());
            Request requestPost = new Request.Builder()
                    .url("http://10.12.253.23:20600/api/ebuilder/coms/digitalpanel/getData")
                    .method("POST", body)
                    .addHeader("Cookie", headcookie)
                    .addHeader("Content-Type", "application/json")
                    .build();
            Response response  = client.newCall(requestPost).execute();

            int code = response.code();
            log.error("getSaleInfo lkhxshtjeObj:"+code);
            String data = response.body().string();

            log.error("getSaleInfo lkhxshtjeObj:"+data);

            if(StringUtils.isNotBlank(data)){
                lkhxshtjeObj = JSONObject.parseObject(data);
            }
        } catch (IOException e) {
            e.printStackTrace();
            log.error("getSaleInfo lkhxshtjeObj:"+e);
        }
        map.put("lkhxshtjeObj",lkhxshtjeObj);


        //已收款合同金额
        JSONObject yskhtjeObj = new JSONObject();
        try {
            JSONObject params = new JSONObject();
            params.put("compId","f03ca1dcaecd456ebb573a23dbe5075b");
            params.put("pageId","880065951867256872");
            params.put("filter","[{\"value\":\"f26759ae44ef4e2f866b8dc3359b8c8a\",\"conditionComId\":\"d84ed5ccd4204ef595885cad8dde1822\",\"funcType\":\"\",\"filterFields\":[],\"dataType\":\"classification\",\"conditionType\":\"and\"}]");
            params.put("pageFilter","[{\"dataset\":{\"id\":\"30\",\"text\":\"合同收款表\",\"type\":\"LOGIC\",\"groupId\":\"weaver-ebuilder-contract-servicecmdatauFJXHS\",\"isPhysical\":false}}]");
            params.put("cusMenuId","838181366272991264");
            params.put("urlPageTitle","5ZCI5ZCM6Zeo5oi3");

            OkHttpClient client = new OkHttpClient().newBuilder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, params.toJSONString());
            Request requestPost = new Request.Builder()
                    .url("http://10.12.253.23:20600/api/ebuilder/coms/digitalpanel/getData")
                    .method("POST", body)
                    .addHeader("Cookie", headcookie)
                    .addHeader("Content-Type", "application/json")
                    .build();
            Response response  = client.newCall(requestPost).execute();

            int code = response.code();
            log.error("getSaleInfo yskhtjeObj:"+code);
            String data = response.body().string();
            log.error("getSaleInfo yskhtjeObj:"+data);
            if(StringUtils.isNotBlank(data)){
                yskhtjeObj = JSONObject.parseObject(data);
            }
        } catch (IOException e) {
            e.printStackTrace();
            log.error("getSaleInfo yskhtjeObj:"+e);
        }
        map.put("yskhtjeObj",yskhtjeObj);


        map.put("yxht","0");
        map.put("xkh","0");;
        map.put("lkh","0");
        map.put("yskhtje","0");
        return map;
    }

}
