package com.weaver.seconddev.jcldoor.cmd;

import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 项目验收信息
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/14
 */
@Component
public class ProjectAcceptanceInfoCmd {

    //日志
    private final static Logger log = LoggerFactory.getLogger(ProjectAcceptanceInfoCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    public String tenant_key = "t7akvdnf84" ;

    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = new HashMap<String,Object>();

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        try {

            String employeeId = request.getParameter("employeeId");
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }
            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            dataMap.put("employeeId",employeeId);
            dataMap.put("startday",startday);
            dataMap.put("endday",endday);

            String groupId = "weaver-ebuilder-form-service";
            String sourceType = "LOGIC";

            String sql =" select CONVERT(ifnull(sum(cast(t1.htzje as decimal(18,2))),0),CHAR) as htzje," +
                    "        CONVERT(ifnull(sum(cast(t1.htyxje as decimal(18,2))),0),CHAR) as htyxje," +
                    "        CONVERT(ifnull(sum(cast(t1.sumsk as decimal(18,2))),0),CHAR) as sumsk " +
                    " from uf_jxhs_xmys t1 \n" +
                    " where t1.ysrq>='" +startday+"' and t1.ysrq<='"+endday+"' " +
                    " and ( t1.qyjl = '"+employeeId+"' "+
                    "       or t1.qyjl in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.ysry = '"+employeeId+"'\n" +
                    "       or t1.ysry in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.dqfzr = '"+employeeId+"'\n" +
                    "       or t1.dqfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.tdjl = '"+employeeId+"'\n" +
                    "       or t1.tdjl in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.tdfzr = '"+employeeId+"'\n" +
                    "       or t1.tdfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.jgfzr = '"+employeeId+"'\n" +
                    "       or t1.jgfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.dqzj = '"+employeeId+"'\n" +
                    "       or t1.dqzj in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"') " +
                    " ) " ;

            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            dataMap.put("datas",recordList.get(0));

        } catch (Exception e) {
            e.printStackTrace();
            log.error("PorojectAcceptanceInfoCmd:"+e.getMessage());
        }
        return dataMap;
    }
}
