package com.weaver.seconddev.jcldoor.cmd;

import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 项目人员综合信息（收款信息+验收信息）
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/14
 */
@Component
public class ProjectCollaborationInfoCmd {

    //日志
    private final static Logger log = LoggerFactory.getLogger(ProjectCollaborationInfoCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    public String tenant_key = "t7akvdnf84";



    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = new HashMap<String,Object>();
        String employeeId = request.getParameter("employeeId");
        String startday = request.getParameter("startday");
        String endday = request.getParameter("endday");

        //项目验收信息
        Map<String,Object> ysMap = getYsInfo(employeeId,startday,endday);
        Map<String,Object> ysdata = (Map<String, Object>) ysMap.get("datas");
        //项目收款信息
        Map<String,Object> skMap = getSkInfo(employeeId,startday,endday);
        Map<String,Object> skdata = (Map<String, Object>) skMap.get("datas");

        dataMap.put("ysdata",ysdata);
        dataMap.put("skdata",skdata);
        return dataMap;
    }

    private Map<String,Object> getYsInfo(String employeeId,String startday,String endday){

        Map<String,Object> dataMap = new HashMap<String,Object>();

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        try {
            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }
            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            dataMap.put("employeeId",employeeId);
            dataMap.put("startday",startday);
            dataMap.put("endday",endday);

            String groupId = "weaver-ebuilder-form-service";
            String sourceType = "LOGIC";

            String sql =" select CONVERT(ifnull(sum(cast(t1.htzje as decimal(18,2))),0),CHAR) as htzje," +
                    "        CONVERT(ifnull(sum(cast(t1.htyxje as decimal(18,2))),0),CHAR) as htyxje," +
                    "        CONVERT(ifnull(sum(cast(t1.sumsk as decimal(18,2))),0),CHAR) as sumsk " +
                    " from uf_jxhs_xmys t1 \n" +
                    " where t1.ysrq>='" +startday+"' and t1.ysrq<='"+endday+"' " +
                    " and ( t1.qyjl = '"+employeeId+"' "+
                    "       or t1.qyjl in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.ysry = '"+employeeId+"'\n" +
                    "       or t1.ysry in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.dqfzr = '"+employeeId+"'\n" +
                    "       or t1.dqfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.tdjl = '"+employeeId+"'\n" +
                    "       or t1.tdjl in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.tdfzr = '"+employeeId+"'\n" +
                    "       or t1.tdfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.jgfzr = '"+employeeId+"'\n" +
                    "       or t1.jgfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                    "       or t1.dqzj = '"+employeeId+"'\n" +
                    "       or t1.dqzj in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"') " +
                    " ) " ;

            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            dataMap.put("datas",recordList.get(0));

        } catch (Exception e) {
            e.printStackTrace();
            log.error("PorojectAcceptanceInfoCmd:"+e.getMessage());
        }
        return dataMap;
    }


    public Map<String, Object> getSkInfo(String employeeId,String startday,String endday) {
        Map<String,Object> dataMap = new HashMap<String,Object>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        try {

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            dataMap.put("employeeId",employeeId);
            dataMap.put("startday",startday);
            dataMap.put("endday",endday);

            String groupId = "weaver-ebuilder-form-service";
            String sourceType = "LOGIC";

            String sql =" SELECT \n" +
                    "   CONVERT(ifnull(sum(cast(t1.skje as decimal(18,2))),0),CHAR) as skje,\n" +  //收款金额
                    "   CONVERT(ifnull(sum(cast(t1.xmskje as decimal(18,2))),0),CHAR) as xmskje,\n" + // 项目收款金额
                    "   CONVERT(ifnull(sum(cast(t1.xsyxje as decimal(18,2))),0),CHAR) as xsyxje," + // 销售有效金额
                    "   CONVERT(ifnull(sum(cast(t1.xsje as decimal(18,2))),0),CHAR) as xsje," + // 销售金额
                    "   CONVERT(ifnull(sum(cast(t1.xmyxje as decimal(18,2))),0),CHAR) as xmyxje," + //项目有效金额
                    "   CONVERT(ifnull(sum(cast(t1.xsjxhk as decimal(18,2))),0),CHAR) as xsjxhk," + //有效绩效回款
                    "   CONVERT(ifnull(sum(cast(t1.sumsk as decimal(18,2))),0),CHAR) as sumsk," + //总收款金额
                    "   CONVERT(ifnull(sum(cast(t1.sjjsk as decimal(18,2))),0),CHAR) as sjjsk," + //实际结算款
                    "   CONVERT(ifnull(sum(cast(t1.skjs as decimal(18,2))),0),CHAR) as skjs " +  //收款结算
                    " FROM uf_jxhs_skmx t1\n" +
                    " LEFT JOIN uf_jxhs_zxhtzb t2 ON t1.hth = t2.hth AND t2.hth != '' AND t2.hth IS NOT NULL \n" +
                    " LEFT JOIN ebdf_physical_data epd on t1.id = epd.form_data_id  and epd.delete_type = 0 \n" +
                    " WHERE t1.skje != 0 \n" +
                    " and t1.skje IS NOT NULL " +
                    " and t1.xshsny >= '" + startday+"' and t1.xshsny <='"+endday+"' "+
                    " and (" +
                    "   '"+employeeId+"' IN ( 2, 27, 166, 10285, 11661, 300, 876, 3593, 1416, 1647, 1844,3044480226941419013,794508876297846787 ) \n" +
                    "   or cast(t1.xsjl AS decimal(25,0)) in( \n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid = '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    "   or cast(t1.kfry AS decimal(25,0)) in(\n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    "   or cast(t1.qdjl AS decimal(25,0)) in(\n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    "   or cast(t1.xmjl AS decimal(25,0)) in(\n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    " )\n" +
                    " order by t1.id " ;

            log.error("PorojectReceiptsInfoCmd sql:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(!CollectionUtils.isEmpty(recordList)){
                dataMap.put("datas",recordList.get(0));
            }


        } catch (Exception e) {
            e.printStackTrace();
            log.error("PorojectReceiptsInfoCmd Exception:"+e);
        }
        return dataMap;
    }
}
