package com.weaver.seconddev.jcldoor.cmd;

import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 项目收款信息
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/14
 */
@Component
public class ProjectReceiptsInfoCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(ProjectReceiptsInfoCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    public String tenant_key = "t7akvdnf84" ;

    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = new HashMap<String,Object>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        try {
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");
            String employeeId = request.getParameter("employeeId");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            dataMap.put("employeeId",employeeId);
            dataMap.put("startday",startday);
            dataMap.put("endday",endday);

            String groupId = "weaver-ebuilder-form-service";
            String sourceType = "LOGIC";

            String sql =" SELECT \n" +
                    "   CONVERT(ifnull(sum(cast(t1.skje as decimal(18,2))),0),CHAR) as skje,\n" +  //收款金额
                    "   CONVERT(ifnull(sum(cast(t1.xmskje as decimal(18,2))),0),CHAR) as xmskje,\n" + // 项目收款金额
                    "   CONVERT(ifnull(sum(cast(t1.xsyxje as decimal(18,2))),0),CHAR) as xsyxje," + // 销售有效金额
                    "   CONVERT(ifnull(sum(cast(t1.xsje as decimal(18,2))),0),CHAR) as xsje," + // 销售金额
                    "   CONVERT(ifnull(sum(cast(t1.xmyxje as decimal(18,2))),0),CHAR) as xmyxje," + //项目有效金额
                    "   CONVERT(ifnull(sum(cast(t1.xsjxhk as decimal(18,2))),0),CHAR) as xsjxhk," + //有效绩效回款
                    "   CONVERT(ifnull(sum(cast(t1.sumsk as decimal(18,2))),0),CHAR) as sumsk," + //总收款金额
                    "   CONVERT(ifnull(sum(cast(t1.sjjsk as decimal(18,2))),0),CHAR) as sjjsk," + //实际结算款
                    "   CONVERT(ifnull(sum(cast(t1.skjs as decimal(18,2))),0),CHAR) as skjs " +  //收款结算
                    " FROM uf_jxhs_skmx t1\n" +
                    " LEFT JOIN uf_jxhs_zxhtzb t2 ON t1.hth = t2.hth AND t2.hth != '' AND t2.hth IS NOT NULL \n" +
                    " LEFT JOIN ebdf_physical_data epd on t1.id = epd.form_data_id  and epd.delete_type = 0 \n" +
                    " WHERE t1.skje != 0 \n" +
                    " and t1.skje IS NOT NULL " +
                    " and t1.xshsny >= '" + startday+"' and t1.xshsny <='"+endday+"' "+
                    " and (" +
                    "   '"+employeeId+"' IN ( 2, 27, 166, 10285, 11661, 300, 876, 3593, 1416, 1647, 1844,3044480226941419013,794508876297846787 ) \n" +
                    "   or cast(t1.xsjl AS decimal(25,0)) in( \n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid = '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    "   or cast(t1.kfry AS decimal(25,0)) in(\n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    "   or cast(t1.qdjl AS decimal(25,0)) in(\n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    "   or cast(t1.xmjl AS decimal(25,0)) in(\n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    " )\n" +
                    " order by t1.id " ;

            log.error("PorojectReceiptsInfoCmd sql:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(!CollectionUtils.isEmpty(recordList)){
                dataMap.put("datas",recordList.get(0));
            }


        } catch (Exception e) {
            e.printStackTrace();
            log.error("PorojectReceiptsInfoCmd Exception:"+e);
        }
        return dataMap;
    }
}
