package com.weaver.seconddev.jcldoor.controller;

import com.alibaba.fastjson.JSONObject;
import com.weaver.common.authority.annotation.WeaPermission;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.em.msg.api.rest.OaRest;
import com.weaver.framework.remote.client.rest.RestClient;
import com.weaver.framework.rpc.annotation.RpcReference;
import com.weaver.seconddev.jcldoor.util.CommonUtils;
import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.teams.blog.domain.RemoteBlogInfoService;
import com.weaver.teams.client.doc.remote.DocClientService;
import com.weaver.teams.domain.hr.RemoteHrKpiService;
import com.weaver.teams.domain.hr.entity.FlowData;
import com.weaver.teams.domain.hr.entity.FlowDataListReq;
import com.weaver.teams.domain.hr.entity.FlowDataListRes;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import com.weaver.workflow.common.constant.list.listdimension.RequestListInitDimensionTabEnum;
import com.weaver.workflow.common.entity.list.api.RequestListConditionApiEntity;
import com.weaver.workflow.common.entity.list.api.publicapi.RequestCountInfoPAEntity;
import com.weaver.workflow.common.entity.list.api.publicapi.RequestListInfoPAEntity;
import com.weaver.workflow.list.api.rest.publicapi.WflRequestListRest;
import com.weaver.workrelate.performance.api.rest.RemotePerformanceService;
import okhttp3.*;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import sun.misc.BASE64Decoder;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.time.*;
import java.time.format.DateTimeFormatter;
import java.time.temporal.TemporalAdjusters;
import java.util.*;

@RestController
@RequestMapping("/api/secondev/njjcldoor")
public class HrmSelfHelpController {

    //日志
    private final Logger log = LoggerFactory.getLogger(HrmSelfHelpController.class);

    @Autowired
    private RestClient restClient;

    @RpcReference
    public RemotePerformanceService remotePerformanceService ;

    @RpcReference
    public RemoteHrKpiService remoteHrKpiService ;

    @RpcReference(group = "workflow")
    WflRequestListRest wflRequestListRest;

    @RpcReference
    DocClientService docClientService;

    @RpcReference
    private OaRest oaRest;

    @RpcReference
    private RemoteBlogInfoService remoteBlogInfoService ;

    @Autowired
    private DatabaseUtils databaseUtils;


    public String tenant_key = "t7akvdnf84" ;

    /**
     *
     * @param request
     * @return
     */
    @GetMapping("/testSapi1")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getColumsCustomerName(HttpServletRequest request){
        log.error("testSapi");
        Map response = new HashMap<>();
        String ids = request.getParameter("ids");

        log.error("testSapi-ids:"+ids);

        try{
            response = restClient.postForObject("/openserver/sapi/architecture/v1/external/query/employee/list", request, Map.class);
            log.error("testSapi-response"+response.toString());
        }catch (Exception e){
            log.error("testSapi-Exception:"+e);
        }

        return WeaResult.success(response);
    }


//    @GetMapping("/testSapi2")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> getColumsCustomerName2(HttpServletRequest request){
//        // 1、请求头
//        HttpHeaders httpHeaders = new HttpHeaders();
//
//        httpHeaders.add("header", "value");
//        HttpEntity<String> requestEntity = new HttpEntity<>(null, httpHeaders);
//        // 3、请求体参数
//        List<String> list = new ArrayList<>(100);
//        list.add("6488080121949444347");
//        Map<String,Object> params = new HashMap<>();
//        params.put("ids",list);
//        // 4、请求接⼝，获取返回信息，参数拼接在url后⾯
//        RestTemplate restTemplate = new RestTemplateBuilder().build();
//        ResponseEntity<WeaResult> responseEntity = restTemplate.exchange(BaseHttpUtil.urlConcatenation("/sapi/architecture/v1/external/query/employee/list",params), HttpMethod.GET, requestEntity, WeaResult.class);
//        // 5、获取返回信息
//        WeaResult weaResult = responseEntity.getBody();
//        return weaResult;



    @GetMapping("/testSapi3")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi3(HttpServletRequest request){
        String request_cookie = "" ;
        Cookie[] cookies = request.getCookies();
        for (Cookie cookie : cookies){
            //判断携带的cookie是否正确
            String cookiename = cookie.getName();
            String cookievalue = cookie.getValue();

            log.error("cookiename3:"+cookiename);
            log.error("cookievalue3:"+cookievalue);

            request_cookie += StringUtils.isBlank(request_cookie) ? cookiename+"="+cookievalue : "; "+cookiename+"="+cookievalue ;
        }

        log.error("request_cookie3:"+request_cookie);
        log.error("3333333333");

        JSONObject jsonObject = new JSONObject();
        try {
            String content = "{\"beginDate\": \"2024-01-01\", \"endDate\": \"2024-01-31\", \"userId\": \"6488080121949444347\"}";

            OkHttpClient client = new OkHttpClient().newBuilder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, content);
            Request request3 = new Request.Builder()
                    .url("http://10.12.253.23:20600/api/attend/web/attendInfoV2/getAttendInfoStatis")
                    .method("POST", body)
                    .addHeader("Cookie", request_cookie)
                    .addHeader("Content-Type", "application/json")
                    .build();
            Response response  = client.newCall(request3).execute();

            int code = response.code();
            String data = response.body().string();

            log.error("code3:"+code);
            log.error("data3:"+data);

            if(StringUtils.isNotBlank(data)){
                jsonObject = JSONObject.parseObject(data);
            }
        } catch (IOException e) {
            e.printStackTrace();
            log.error("testSapi3-e:"+e);
        }

        jsonObject.put("test111","testSapi3");
        return WeaResult.success(jsonObject.toString());
    }


    @GetMapping("/testSapi4")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi4(HttpServletRequest request){

        String urlip = request.getParameter("urlip") ;
        String urlpath = request.getParameter("urlpath") ;

        log.error("urlip41:"+urlip);
        log.error("urlpath41:"+urlpath);

        BASE64Decoder decoder = new BASE64Decoder();
        try {
            if(StringUtils.isNotBlank(urlip)){
                urlip = new String(decoder.decodeBuffer(urlip),"UTF-8");
            }
            log.error("urlip42:"+urlip);

            if(StringUtils.isNotBlank(urlpath)){
                urlpath = new String(decoder.decodeBuffer(urlpath),"UTF-8");
            }
            log.error("urlpath42:"+urlpath);

        } catch (IOException e) {
            e.printStackTrace();
        }


        String beginDate = request.getParameter("beginDate") ;
        String endDate = request.getParameter("endDate") ;
        String userId = request.getParameter("userId") ;
        String request_cookie = "" ;

        Cookie[] cookies = request.getCookies();
        for (Cookie cookie:cookies){
            //判断携带的cookie是否正确
            String cookiename = cookie.getName();
            String cookievalue = cookie.getValue();

            log.error("cookiename4:"+cookiename);
            log.error("cookievalue4:"+cookievalue);

            request_cookie += StringUtils.isBlank(request_cookie) ? cookiename+"="+cookievalue : "; "+cookiename+"="+cookievalue ;

        }

        log.error("request_cookie4:"+request_cookie);
        log.error("4444444444444444");

        JSONObject jsonObject = new JSONObject();

        try {
            String content = "{\"beginDate\": \""+beginDate+"\", \"endDate\": \""+endDate+"\", \"userId\": \""+userId+"\"}" ;

            log.error("content4:"+content);
            OkHttpClient client = new OkHttpClient().newBuilder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, content);
            Request request3 = new Request.Builder()
                    .url(urlip+urlpath)
                    .method("POST", body)
                    .addHeader("Cookie", request_cookie)
                    .addHeader("Content-Type", "application/json")
                    .build();
            Response response  = client.newCall(request3).execute();
            String data = response.body().toString();
            log.error("data4:"+data);
            if(StringUtils.isNotBlank(data)){
                jsonObject = JSONObject.parseObject(data);
            }
        } catch (IOException e) {
            e.printStackTrace();
            log.error("testSapi4-e:"+e);
        }
        log.error("jsonObject4:"+jsonObject.toString());

        return WeaResult.success(jsonObject.toString());
    }


    @GetMapping("/testSapi5")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi5(HttpServletRequest request){

        String request_cookie = "" ;
        Cookie[] cookies = request.getCookies();

        for (Cookie cookie : cookies){
            //判断携带的cookie是否正确
            log.error("getName5:" + cookie.getName());
            log.error("getValue5:" + cookie.getValue());

            String cookiename = cookie.getName();
            String cookievalue = cookie.getValue();
            if("langType".equals(cookiename) || " ETEAMS_TGC".equals(cookiename) || "JSESSIONID".equals(cookiename) || "ETEAMSID".equals(cookiename)){
                request_cookie += StringUtils.isBlank(request_cookie) ? cookiename+"="+cookievalue : "; "+cookiename+"="+cookievalue ;
            }

        }

        log.error("request_cookie5:"+request_cookie);
        log.error("55555555");

        JSONObject jsonObject = new JSONObject();
        try {
            String content = "{\"beginDate\": \"2024-01-01\", \"endDate\": \"2024-01-31\", \"userId\": \"6488080121949444347\"}";

            OkHttpClient client = new OkHttpClient().newBuilder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, content);
            Request request3 = new Request.Builder()
                    .url("http://10.12.253.23:20600/api/attend/web/attendInfoV2/getAttendInfoStatis")
                    .method("POST", body)
                    .addHeader("Cookie", request_cookie)
                    .addHeader("Content-Type", "application/json")
                    .build();
            Response response  = client.newCall(request3).execute();
            int code = response.code();
            log.error("code5:"+code);

            String data = response.body().string();
            log.error("data5:"+data);

            if(StringUtils.isNotBlank(data)){
                jsonObject = JSONObject.parseObject(data);
            }
        } catch (IOException e) {
            e.printStackTrace();
            log.error("testSapi5-e:"+e);
        }
        jsonObject.put("test111","testSapi5");
        return WeaResult.success(jsonObject.toString());
    }



    @GetMapping("/testSapi6")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi6(HttpServletRequest request){

        String headcookie = request.getHeader("Cookie");
        String Eteamsid = request.getHeader("Eteamsid");

        log.error("testSapi6");

        log.error("headcookie6:"+headcookie);
        log.error("6666666111111");
        log.error("Eteamsid:"+Eteamsid);
        log.error("66666222222");

        JSONObject jsonObject = new JSONObject();
        try {
            String content = "{\"beginDate\": \"2024-01-01\", \"endDate\": \"2024-01-31\", \"userId\": \"6488080121949444347\"}";

            OkHttpClient client = new OkHttpClient().newBuilder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, content);
            Request request3 = new Request.Builder()
                    .url("http://10.12.253.23:20600/api/attend/web/attendInfoV2/getAttendInfoStatis")
                    .method("POST", body)
                    .addHeader("Cookie", headcookie)
                    .addHeader("Eteamsid", Eteamsid)
                    .addHeader("Content-Type", "application/json")
                    .build();
            Response response  = client.newCall(request3).execute();

            int code = response.code();
            log.error("code6:"+code);

            String data = response.body().string();
            log.error("data6:"+data);

            if(StringUtils.isNotBlank(data)){
                jsonObject = JSONObject.parseObject(data);
            }
        } catch (IOException e) {
            e.printStackTrace();
            log.error("testSapi6:"+e);
        }

        jsonObject.put("test111","testSapi6");
        return WeaResult.success(jsonObject.toString());
    }


    @GetMapping("/testSapi7")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi7(HttpServletRequest request){

        String headcookie = request.getHeader("Cookie");

        log.error("testSapi7");

        log.error("testSapi7:"+headcookie);
        log.error("6666666111111");

        JSONObject jsonObject = new JSONObject();
        try {
            String content = "{\"beginDate\": \"2024-04-01\", \"endDate\": \"2024-04-30\", \"userId\": \"6488080121949444347\"}";

            OkHttpClient client = new OkHttpClient().newBuilder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, "{\"beginDate\": \"2024-01-01\", \"endDate\": \"2024-01-31\", \"userId\": \"6488080121949444347\"}");
            Request request3 = new Request.Builder()
                    .url("http://10.12.253.23:20600/api/attend/web/attendInfoV2/getAttendInfoStatis")
                    .method("POST", body)
                    .addHeader("Cookie", headcookie)
                    .addHeader("Content-Type", "application/json")
                    .build();
            Response response  = client.newCall(request3).execute();

            int code = response.code();
            log.error("code7:"+code);
            String data = response.body().string();

            log.error("data7:"+data);

            if(StringUtils.isNotBlank(data)){
                jsonObject = JSONObject.parseObject(data);
            }
        } catch (IOException e) {
            e.printStackTrace();
            log.error("testSapi6:"+e);
        }

        jsonObject.put("test111","testSapi7");
        return WeaResult.success(jsonObject.toString());
    }


    @GetMapping("/testSapi8")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi8(HttpServletRequest request){

        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData

        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi8");
        try {
            FlowDataListReq flowDataListReq = new FlowDataListReq();
            flowDataListReq.setCurrent(1);
            flowDataListReq.setPageSize(20);
            flowDataListReq.setStartTime("2024-01-01");
            flowDataListReq.setEndTime("2024-01-31");
            flowDataListReq.setDateType("month");
            flowDataListReq.setTenantKey("t7akvdnf84");
            List<Long> userList = new ArrayList<Long>();
            Long employeeId = UserContext.getCurrentEmployeeId();
            userList.add(employeeId);
            flowDataListReq.setUserList(userList);
            FlowData flowData = remotePerformanceService.queryFlowData(flowDataListReq);

            Long total = flowData.getTotal();
            dataMap.put("total",total+"");
            List<FlowDataListRes>  flowDataList = flowData.getDataList();
            for(int i = 0 ;i<flowDataList.size();i++){
                FlowDataListRes flowDataListRes = flowDataList.get(i);
                Long UserId = flowDataListRes.getUserId();
                float Score = flowDataListRes.getScore();

                dataMap.put("UserId",UserId+"");
                dataMap.put("Score",Score+"");
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi8:"+e);
        }
        return WeaResult.success(dataMap);
    }


    @GetMapping("/testSapi9")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi9(HttpServletRequest request){

        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi9");
        try {
            Long employeeId = UserContext.getCurrentEmployeeId();
            String TenantKey = "t7akvdnf84";
            dataMap = remoteHrKpiService.getKpiFLowById(employeeId,TenantKey);
        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi8:"+e);
        }
        return WeaResult.success(dataMap);
    }


    @GetMapping("/testSapi10")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi10(HttpServletRequest request){

        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi10");
        try {

            SimpleEmployee employee = UserContext.getCurrentUser();

            RequestListConditionApiEntity conditionEntity = new RequestListConditionApiEntity();
            WeaResult<RequestCountInfoPAEntity>  RequestCountInfoPAEntity = wflRequestListRest.getRequestCountByTabId(employee, RequestListInitDimensionTabEnum.DONE_FLOWALL.getTabid(), conditionEntity);
            int code = RequestCountInfoPAEntity.getCode();
            Long count = RequestCountInfoPAEntity.getData().getCount();

            dataMap.put("code",code);
            dataMap.put("count",count);

        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi10:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }


    @GetMapping("/testSapi11")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi11(HttpServletRequest request){

        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi11");
        try {
            SimpleEmployee employee = UserContext.getCurrentUser();



            RequestListConditionApiEntity conditionEntity = new RequestListConditionApiEntity();
            WeaResult<RequestCountInfoPAEntity>  RequestCountInfoPAEntity = wflRequestListRest.getRequestCountByTabId(employee, RequestListInitDimensionTabEnum.MINE_FLOWALL.getTabid(), conditionEntity);
            int code = RequestCountInfoPAEntity.getCode();
            Long count = RequestCountInfoPAEntity.getData().getCount();

            dataMap.put("code",code);
            dataMap.put("count",count);

        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi11:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }


    @GetMapping("/testSapi12")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi12(HttpServletRequest request){
        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi12");
        try {
            long employeeId = UserContext.getCurrentEmployeeId();
            int doccreatecount = docClientService.countByCreator(employeeId);
            dataMap.put("employeeId",employeeId);
            dataMap.put("count",doccreatecount);
        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi12:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }



    @GetMapping("/testSapi13")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi13(HttpServletRequest request){
        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi13");

        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        try {

            SimpleEmployee employee = UserContext.getCurrentUser();

            Calendar cal = Calendar.getInstance();
            int year = cal.get(Calendar.YEAR);
            String startDate = year+"-01-01";

            //设置当前时间
            cal.setTime(new Date());
            //同理增加一天的方法：
            cal.add(Calendar.DATE, 1);
            String endDate = format.format(cal.getTime());

            Long cid = employee.getCid();
            String pageSize = "100";
            String pageNum = "1";

            Map<String, Object> json = new HashMap<String, Object>();
            json.put("cid",cid);
            json.put("pageNum",pageNum);
            json.put("pageSize",pageSize);
            json.put("startDate",startDate);
            json.put("endDate",endDate);

            com.weaver.em.msg.api.entity.Request emrequest = new com.weaver.em.msg.api.entity.Request();
            emrequest.setUrl("/user-profile/groupSession");
            emrequest.setParamsMap(json);
            com.weaver.em.msg.api.entity.Response response = oaRest.executeIm(emrequest);

            String data = response.getData();
            dataMap.put("datas",data);

        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi13:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }


    @GetMapping("/testSapi14")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi14(HttpServletRequest request){
        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi14");

        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        try {

            SimpleEmployee employee = UserContext.getCurrentUser();

            Calendar cal = Calendar.getInstance();
            int year = cal.get(Calendar.YEAR);
            String startDate = year+"-01-01";

            //设置当前时间
            cal.setTime(new Date());
            //同理增加一天的方法：
            cal.add(Calendar.DATE, 1);
            String endDate = format.format(cal.getTime());

            Long cid = employee.getCid();
            String pageSize = "100";
            String pageNum = "1";

            Map<String, Object> json = new HashMap<String, Object>();
            json.put("cid",cid);
            json.put("pageNum",pageNum);
            json.put("pageSize",pageSize);
            json.put("startDate",startDate);
            json.put("endDate",endDate);

            com.weaver.em.msg.api.entity.Request emrequest = new com.weaver.em.msg.api.entity.Request();
            emrequest.setUrl("/user-profile/dailySingleSession");
            emrequest.setParamsMap(json);
            com.weaver.em.msg.api.entity.Response response = oaRest.executeIm(emrequest);

            String data = response.getData();
            dataMap.put("datas",data);

        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi14:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }


    @GetMapping("/testSapi15")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi15(HttpServletRequest request){
        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi15");

        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        try {

            LocalDate currentDate = LocalDate.now();
            LocalDate lastMonthDate = currentDate.minusMonths(1);
            int lastMonth = lastMonthDate.getMonthValue();
            log.error("上个月的月份是：" + lastMonth);

            SimpleEmployee employee = UserContext.getCurrentUser();

            long employeeId = UserContext.getCurrentEmployeeId();

            String groupId = "weaver-wr-performance-service";
            String sourceType = "LOGIC";

            Map<String, Object> dataMap1 = getLastMonthKpi(employeeId,groupId,sourceType);

            Map<String, String> dataMap2 = getWholeYearKpi(employeeId,groupId,sourceType);

            dataMap.putAll(dataMap1);
            dataMap.putAll(dataMap2);

            // " select * from HR_KPI_FLOW where kpi_user='6488080121949444347' and REAL_PERIOD>='2024-01-01' and REAL_PERIOD<='2024-01-31' " ;
            // KPI_SCHEME

            //select * from hr_kpi_details where kpi_scheme like '%100001230000006534%'


            //select * from hr_kpi_details_link   where
            //KPI_DETAILS like '%100001200000006534%'
            //and PROPERTY='describe'

//            select * from hr_kpi_details_link   where
//            KPI_DETAILS like '%100001200000006534%'
//            and PROPERTY = 'weight'

//            select * from hr_kpi_details_link   where
//            KPI_DETAILS like '%100001200000006534%'
//            and PROPERTY = 'type'


//            select * from hr_kpi_scheme_indicator
//            where SCHEME_ID='100001230000006534'





        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi14:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }


    /***
     *
     * @param employeeId
     * @param groupId
     * @param sourceType
     * @return
     */
    public Map<String, String> getWholeYearKpi(long employeeId,String groupId,String sourceType){

        Map<String, String> dataMap = new HashMap<String,String>();
        LocalDate localDate = LocalDate.now();
        int year = localDate.getYear() ;
        int dayOfYear = 1 ;
        for(int i=1;i<=12;i++){
            Month month = Month.of(i);
            LocalDate startDay = YearMonth.of(year, month).atDay(dayOfYear); // 计算当前月份的首日
            LocalDate endDay = YearMonth.of(year, month).atEndOfMonth(); // 计算当前月份的最后一天
            String yearMonth = "";
            if(i<10){
                yearMonth = year+"-0"+i ;
            }else{
                yearMonth = year+"-"+i ;
            }

            String sql =" select score from wr-performance.hr_kpi_flow " +
                    " where kpi_user='"+employeeId+"' " +
                    " and REAL_PERIOD >= '" +startDay+"'" +
                    " and REAL_PERIOD <='" + endDay +"'" +
                    " and module = 'kpiFlow'" +
                    " and DATE_TYPE = 'month'" +
                    " and FLOW_STATUS = 'finished'" +
                    " and delete_type = '0'" +
                    " and tenant_key='"+tenant_key+"' " ;

            log.error("sql:"+sql);

            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(CollectionUtils.isNotEmpty(recordList)){
                Map<String,Object> recordMap = recordList.get(0);
                if(!recordMap.isEmpty()){
                    String score = String.valueOf(recordMap.get("score"));
                    if(StringUtils.isNotBlank(score)){
                        dataMap.put(yearMonth,score);
                    }
                }
            }
        }
        return dataMap ;
    }


    public Map<String, Object> getLastMonthKpi(long employeeId, String groupId, String sourceType){

        log.error("getLastMonthKpi:");

        Map<String, Object> dataMap = new HashMap<String,Object>();

        List<Map<String,Object>> indicatorList = new ArrayList<Map<String,Object>>();

        LocalDate localDate = LocalDate.now();
        int year = localDate.getYear() ;
        for(int i=0;i<=12;i++){
            LocalDate previousMonth = localDate.minusMonths(i);
            String startDay = previousMonth.with(TemporalAdjusters.lastDayOfMonth()).toString();
            String endDay = previousMonth.with(TemporalAdjusters.firstDayOfMonth()).toString();
            log.error("startDay:"+startDay);
            log.error("endDay:"+endDay);

            String yearMonth = "";
            if(i<10){
                yearMonth = year+"-0"+i ;
            }else{
                yearMonth = year+"-"+i ;
            }

            String sql =" select kpi_scheme,score " +
                    " from wr-performance.hr_kpi_flow " +
                    " where kpi_user='"+employeeId+"' " +
                    " and real_period >= '" +startDay+"'" +
                    " and real_period <='" + endDay +"'" +
                    " and module = 'kpiFlow'" +
                    " and date_type = 'month'" +
                    " and flow_status = 'finished'" +
                    " and delete_type = '0'" +
                    " and tenant_key='"+tenant_key+"' " ;
            log.error("sql:"+sql);

            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(CollectionUtils.isNotEmpty(recordList)){
                Map<String,Object> recordMap = recordList.get(0);
                if(!recordMap.isEmpty()){
                    String score = String.valueOf(recordMap.get("score"));
                    String kpi_scheme = String.valueOf(recordMap.get("kpi_scheme"));
                    log.error("score:"+score);
                    log.error("kpi_scheme:"+kpi_scheme);
                    if(StringUtils.isNotBlank(score)){
                        dataMap.put("score",score);
                        dataMap.put("yearmonth",yearMonth);
                        dataMap.put("kpi_scheme",kpi_scheme);
                        break;
                    }
                }
            }
        }

        if(!dataMap.isEmpty()){
            String kpi_scheme = String.valueOf(dataMap.get("kpi_scheme"));

            log.error("kpi_scheme:"+kpi_scheme);

            if(StringUtils.isNotBlank(kpi_scheme)){
                String sql =" select indicator_type,indicator_description,weight \n" +
                        " from wr-performance.hr_kpi_scheme_indicator " +
                        " where scheme_id='"+kpi_scheme+"' " +
                        " and indicator_mode='quantify'\n" +
                        " and status='on' " +
                        " and delete_type = '0'" +
                        " and tenant_key = '"+tenant_key+"'" ;
                log.error("sql:"+sql);
                Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);

                log.error("recordList:"+recordList.size());

                if(recordList.size()>=2){
                    for(int i=0;i<2;i++){
                        indicatorList.add(recordList.get(i));
                    }
                }else if(recordList.size() == 1){
                    indicatorList.add(recordList.get(0));

                    Map<String, Object> indicatorMap = new HashMap<String, Object>();
                    sql =   " select name,data_row,property\n" +
                            " from wr-performance.hr_kpi_details_link\n" +
                            " where kpi_details = '"+kpi_scheme+"'\n" +
                            "    and module = 'kpiSchemeSetting'\n" +
                            "    and tenant_key = '"+tenant_key+"'\n" +
                            "    and delete_type = '0'\n" +
                            "    and property in('weight', 'describe', 'type')\n" +
                            "    and data_row in ( \n" +
                            "        select p.data_row from (\n" +
                            "            select w.data_row from (\n" +
                            "                select data_row \n" +
                            "                from wr-performance.hr_kpi_details_link\n" +
                            "                where KPI_DETAILS = '"+kpi_scheme+"'\n" +
                            "                    and PROPERTY = 'weight'\n" +
                            "                    and MODULE = 'kpiSchemeSetting'\n" +
                            "                    and TENANT_KEY = '"+tenant_key+"'\n" +
                            "                    and DELETE_TYPE = '0'\n" +
                            "                    order by name desc\n" +
                            "            ) w limit 1 \n" +
                            "        ) p\n" +
                            "    )";
                    log.error("sql:"+sql);
                    Map<String, Object> result2 = databaseUtils.execute(sourceType, groupId, sql);
                    List<Map<String,Object>> recordList2 = databaseUtils.getDataSourceList(result2);
                    log.error("recordList2:"+recordList2.size());
                    for(int i=0;i<recordList2.size();i++){
                        Map<String,Object> recordMap = recordList2.get(i);
                        String name = String.valueOf(recordMap.get("name"));
                        String property = String.valueOf(recordMap.get("property"));

                        log.error("name:"+name);
                        log.error("property:"+property);

                        if("weight".equalsIgnoreCase(property)){
                            indicatorMap.put("weight",name);
                        }
                        if("describe".equalsIgnoreCase(property)){
                            indicatorMap.put("indicator_description",name);
                        }
                        if("type".equalsIgnoreCase(property)){
                            indicatorMap.put("indicator_type",name);
                        }
                    }

                    if(!indicatorMap.isEmpty()){
                        indicatorList.add(indicatorMap);
                    }

                }else{

                    sql =   "  select w.data_row from (\n" +
                            "    select data_row\n" +
                            "    from wr-performance.hr_kpi_details_link\n" +
                            "    where KPI_DETAILS = '"+kpi_scheme+"'\n" +
                            "        and PROPERTY = 'weight'\n" +
                            "        and MODULE = 'kpiSchemeSetting'\n" +
                            "        and TENANT_KEY = '"+tenant_key+"'\n" +
                            "        and DELETE_TYPE = '0'\n" +
                            "    order by name desc\n" +
                            "    limit 2\n" +
                            ") w " ;

                    Map<String, Object> result3 = databaseUtils.execute(sourceType, groupId, sql);
                    List<Map<String,Object>> recordList3 = databaseUtils.getDataSourceList(result3);
                    for(int k=0;k<recordList3.size();k++){
                        Map<String,Object> recordMap3 = recordList3.get(k);

                        String data_row = String.valueOf(recordMap3.get("data_row"));

                        Map<String, Object> indicatorMap = new HashMap<String, Object>();

                        sql =   " select name,data_row,property\n" +
                                " from wr-performance.hr_kpi_details_link\n" +
                                " where KPI_DETAILS = '"+kpi_scheme+"'\n" +
                                "    and MODULE = 'kpiSchemeSetting'\n" +
                                "    and TENANT_KEY = '"+tenant_key+"'\n" +
                                "    and DELETE_TYPE = '0'\n" +
                                "    and property in('weight', 'describe', 'type')\n" +
                                "    and data_row in("+data_row+")" ;

                        Map<String, Object> result2 = databaseUtils.execute(sourceType, groupId, sql);
                        List<Map<String,Object>> recordList2 = databaseUtils.getDataSourceList(result2);

                        for(int i=0;i<recordList2.size();i++){

                            Map<String,Object> recordMap = recordList2.get(i);

                            String name = String.valueOf(recordMap.get("name"));
                            String property = String.valueOf(recordMap.get("property"));
                            if("weight".equalsIgnoreCase(property)){
                                indicatorMap.put("weight",name);
                            }
                            if("describe".equalsIgnoreCase(property)){
                                indicatorMap.put("indicator_description",name);
                            }
                            if("type".equalsIgnoreCase(property)){
                                indicatorMap.put("indicator_type",name);
                            }
                        }
                    }
                }
            }
        }

        return dataMap ;
    }


    @GetMapping("/testSapi16")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi16(HttpServletRequest request){
        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi16");

        Map<String,Object> recordMap = new HashMap<String,Object>();
        try {

            String day = "30";
            SimpleEmployee employee = UserContext.getCurrentUser();

            long employeeId = UserContext.getCurrentEmployeeId();
            dataMap.put("day",day);
            dataMap.put("employeeId",employeeId);

            String groupId = "weaver-portrait-service";
            String sourceType = "LOGIC";

            String sql ="  SELECT \n" +
                    "  t1.id typeid,\n" +
                    "  t1.name typename,\n" +
                    "  t2.id riskid,\n" +
                    "  t2.name riskname,\n" +
                    "  t.risk_value,\n" +
                    "  t.tenant_key,\n" +
                    "  t.userid," +
                    "  e.username,\n" +
                    "  times \n" +
                    "  FROM (\n" +
                    "        SELECT k.riskid,k.risk_value,k.tenant_key,k.userid,COUNT(k.riskid) times  \n" +
                    "        FROM (\n" +
                    "            SELECT t.riskid,t.risk_value,t.tenant_key,t.userid\n" +
                    "            FROM pr_indrisk_data t \n" +
                    "            WHERE t.delete_type = 0 \n" +
                    "            AND t.tenant_key = '"+tenant_key+"'\n" +
                    "            AND t.risk_date >= DATE_FORMAT(DATE_SUB(CURDATE(), INTERVAL 30 DAY), '%Y-%m-%d')\n" +
                    "            AND  t.userid =  '"+employeeId+"'\n" +
                    "            union all\n" +
                    "            SELECT t.riskid,t.risk_value,t.tenant_key,t.userid\n" +
                    "            FROM pr_indrisk_data t \n" +
                    "            WHERE t.delete_type = 0 \n" +
                    "            AND t.tenant_key = '"+tenant_key+"'\n" +
                    "            AND t.risk_date >= DATE_FORMAT(DATE_SUB(CURDATE(), INTERVAL 30 DAY), '%Y-%m-%d')\n" +
                    "            AND t.userid IN (select cid from eteams.emp_link where pid= '"+employeeId+"' and relation = 'senior') \n" +
                    "        ) k \n" +
                    "        GROUP BY k.riskid,\n" +
                    "        k.risk_value,\n" +
                    "        k.tenant_key,\n" +
                    "        k.userid\n" +
                    "    ) t,\n" +
                    "    pr_indrisk_type t1,\n" +
                    "    pr_indrisk_info t2 ,\n" +
                    "    eteams.employee e\n" +
                    "    WHERE t.riskid = t2.id \n" +
                    "    AND t2.risk_type = t1.id \n" +
                    "    AND t.userid = e.id\n" +
                    "    AND e.STATUS != 'unavailable' AND e.PERMANENTLY_DELETE = '0'\n" +
                    "    AND t1.delete_type = 0 \n" +
                    "    AND t2.delete_type = 0" ;

            log.error("testSapi16:"+sql);

            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            recordMap.put("datas",recordList);
        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi16:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(recordMap);
    }


    @GetMapping("/testSapi17")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi17(HttpServletRequest request){
        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi17");

        Map<String,Object> recordMap = new HashMap<String,Object>();
        try {

            String day = null2String(request.getParameter("day"),"30");
            SimpleEmployee employee = UserContext.getCurrentUser();

            long employeeId = UserContext.getCurrentEmployeeId();

            dataMap.put("day",day);
            dataMap.put("employeeId",employeeId);

            String groupId = "weaver-portrait-service";
            String sourceType = "LOGIC";

            String sql ="  SELECT \n" +
                    "  t1.id typeid,\n" +
                    "  t1.name typename,\n" +
                    "  t2.id riskid,\n" +
                    "  t2.name riskname,\n" +
                    "  t.risk_value,\n" +
                    "  t.tenant_key,\n" +
                    "  t.userid,\n" +
                    "  e.username,\n" +
                    "  times \n" +
                    "  FROM (\n" +
                    "        SELECT k.riskid,k.risk_value,k.tenant_key,k.userid,COUNT(k.riskid) times  \n" +
                    "        FROM (\n" +
                    "            SELECT t.riskid,t.risk_value,t.tenant_key,t.userid\n" +
                    "            FROM portrait.pr_indrisk_data t \n" +
                    "            WHERE t.delete_type = 0 \n" +
                    "            AND t.tenant_key = '"+tenant_key+"'\n" +
                    "            AND t.risk_date >= DATE_FORMAT(DATE_SUB(CURDATE(), INTERVAL "+day+" DAY), '%Y-%m-%d')\n" +
                    "            AND  t.userid =  '"+employeeId+"'\n" +
                    "            union all\n" +
                    "            SELECT t.riskid,t.risk_value,t.tenant_key,t.userid\n" +
                    "            FROM portrait.pr_indrisk_data t \n" +
                    "            WHERE t.delete_type = 0 \n" +
                    "            AND t.tenant_key = '"+tenant_key+"'\n" +
                    "            AND t.risk_date >= DATE_FORMAT(DATE_SUB(CURDATE(), INTERVAL "+day+" DAY), '%Y-%m-%d')\n" +
                    "            AND t.userid IN (select cid from eteams.emp_link where pid= '"+employeeId+"' and relation = 'senior') \n" +
                    "        ) k \n" +
                    "        GROUP BY k.riskid,\n" +
                    "        k.risk_value,\n" +
                    "        k.tenant_key,\n" +
                    "        k.userid\n" +
                    "    ) t,\n" +
                    "    portrait.pr_indrisk_type t1,\n" +
                    "    portrait.pr_indrisk_info t2 ,\n" +
                    "    eteams.employee e\n" +
                    "    WHERE t.riskid = t2.id \n" +
                    "    AND t2.risk_type = t1.id \n" +
                    "    AND t.userid = e.id\n" +
                    "    AND e.STATUS != 'unavailable' AND e.PERMANENTLY_DELETE = '0'\n" +
                    "    AND t1.delete_type = 0 \n" +
                    "    AND t2.delete_type = 0" ;

            log.error("testSapi17:"+sql);

            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            recordMap.put("datas",recordList);
        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi17:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(recordMap);
    }


    @GetMapping("/testSapi18")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi18(HttpServletRequest request){
        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi18");

        Map<String,Object> recordMap = new HashMap<String,Object>();
        try {

            String day = null2String(request.getParameter("day"),"30");
            SimpleEmployee employee = UserContext.getCurrentUser();

            String startDay = "";
            if(StringUtils.isNotBlank(day)){
                int day_ = Integer.parseInt(day);
                LocalDate today = LocalDate.now(); // 获取当前日期
                LocalDate tenDaysBefore = today.minusDays(day_); // 当前日期前10天
                startDay = tenDaysBefore.toString();
            }else{
                LocalDate today = LocalDate.now(); // 获取当前日期
                LocalDate tenDaysBefore = today.minusDays(30); // 当前日期前10天
                startDay = tenDaysBefore.toString();
            }
            long employeeId = UserContext.getCurrentEmployeeId();

            dataMap.put("day",day);
            dataMap.put("employeeId",employeeId);

            String groupId = "weaver-portrait-service";
            String sourceType = "LOGIC";

            String sql ="  SELECT \n" +
                    "  t1.id typeid,\n" +
                    "  t1.name typename,\n" +
                    "  t2.id riskid,\n" +
                    "  t2.name riskname,\n" +
                    "  t.risk_value,\n" +
                    "  t.tenant_key,\n" +
                    "  t.userid,\n" +
                    "  e.username,\n" +
                    "  times \n" +
                    "  FROM ( \n" +
                    "        SELECT k.riskid,k.risk_value,k.tenant_key,k.userid,COUNT(k.riskid) times  \n" +
                    "        FROM (\n" +
                    "            SELECT t.riskid,t.risk_value,t.tenant_key,t.userid\n" +
                    "            FROM pr_indrisk_data t \n" +
                    "            WHERE t.delete_type = 0 \n" +
                    "            AND t.tenant_key = '"+tenant_key+"'\n" +
                    "            AND t.risk_date >= '"+startDay+"'\n" +
                    "            AND  t.userid = '"+employeeId+"'\n" +
                    "            union all\n" +
                    "            SELECT t.riskid,t.risk_value,t.tenant_key,t.userid \n" +
                    "            FROM pr_indrisk_data t \n" +
                    "            WHERE t.delete_type = 0 \n" +
                    "            AND t.tenant_key = '"+tenant_key+"' \n" +
                    "            AND t.risk_date >= '"+startDay+"' \n" +
                    "            AND t.userid IN (select cid from eteams.emp_link where pid= '"+employeeId+"' and relation = 'senior') \n" +
                    "        ) k \n" +
                    "        GROUP BY k.riskid,\n" +
                    "        k.risk_value,\n" +
                    "        k.tenant_key,\n" +
                    "        k.userid\n" +
                    "    ) t,\n" +
                    "    pr_indrisk_type t1,\n" +
                    "    pr_indrisk_info t2 ,\n" +
                    "    eteams.employee e\n" +
                    "    WHERE t.riskid = t2.id \n" +
                    "    AND t2.risk_type = t1.id \n" +
                    "    AND t.userid = e.id\n" +
                    "    AND e.STATUS != 'unavailable' AND e.PERMANENTLY_DELETE = '0'\n" +
                    "    AND t1.delete_type = 0 \n" +
                    "    AND t2.delete_type = 0" ;

            log.error("testSapi17:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            for(int i=0;i<recordList.size();i++){
                Map<String,Object>  recordMap2 = recordList.get(i);
                recordMap2.put("pid",i+"");
            }
            recordMap.put("datas",recordList);
        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi17:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(recordMap);
    }



    @GetMapping("/testSapi20")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi20(HttpServletRequest request){
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi20");

        try {

            String employeeId = request.getParameter("employeeId");
            LocalDate currentDate = LocalDate.now();
            LocalDate lastMonthDate = currentDate.minusMonths(1);
            int lastMonth = lastMonthDate.getMonthValue();
            log.error("上个月的月份是20：" + lastMonth);

            SimpleEmployee employee = UserContext.getCurrentUser();

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            String groupId = "weaver-ebuilder-form-service";
            String sourceType = "LOGIC";

            Map<String, Object> scoreMap = getLastMonthKpi2(employeeId,groupId,sourceType);

            List<Map<String, String>> yearList = getWholeYearKpi2(employeeId,groupId,sourceType);

            dataMap.put("scoreMap",scoreMap);
            dataMap.put("yearList",yearList);

        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi20:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }



    public Map<String, Object> getLastMonthKpi2(String employeeId, String groupId, String sourceType){

        log.error("getLastMonthKpi20");

        Map<String, Object> dataMap = new HashMap<String,Object>();

        List<Map<String,Object>> indicatorList = new ArrayList<Map<String,Object>>();

        if(StringUtils.isNotBlank(employeeId)){
            String sql =" select left(k.real_period,10) as real_period,left(k.real_period,7) as period_month,k.kpi_scheme,k.score\n" +
                    " from (select real_period,kpi_scheme,score\n" +
                    "       from hr_kpi_flow  \n" +
                    "       where kpi_user='"+employeeId+"'  \n" +
                    "       and module = 'kpiFlow' \n" +
                    "       and date_type = 'month' \n" +
                    "       and delete_type = '0' " +
                    "       and tenant_key='"+tenant_key+"'\n" +
                    "       and FLOW_STATUS in('noApprove','approve','finished')\n" +
                    "       order by real_period desc\n" +
                    ") k  limit 1 ";

            log.error("sql20-1:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(CollectionUtils.isNotEmpty(recordList)){
                Map<String,Object> recordMap = recordList.get(0);
                if(!recordMap.isEmpty()){
                    String score = String.valueOf(recordMap.get("score"));
                    String kpi_scheme = String.valueOf(recordMap.get("kpi_scheme"));
                    String real_period = String.valueOf(recordMap.get("real_period"));
                    String period_month = String.valueOf(recordMap.get("period_month"));

                    dataMap.put("score",score);
                    dataMap.put("yearmonth",period_month);
                    dataMap.put("kpi_scheme",kpi_scheme);
                    dataMap.put("real_period",real_period);
                }
            }
        }

//        LocalDate localDate = LocalDate.now();
//        int year = localDate.getYear() ;
//        for(int i=0;i<=12;i++){
//            LocalDate previousMonth = localDate.minusMonths(i);
//            String startDay = previousMonth.with(TemporalAdjusters.lastDayOfMonth()).toString();
//            String endDay = previousMonth.with(TemporalAdjusters.firstDayOfMonth()).toString();
//            log.error("startDay20:"+startDay);
//            log.error("endDay20:"+endDay);
////                    " select kpi_scheme,score " +
////                        " from hr_kpi_flow " +
////                        " where kpi_user='"+employeeId+"' " +
////                        " and real_period >= '" +startDay+"'" +
////                        " and real_period <='" + endDay +"'" +
////                        " and module = 'kpiFlow'" +
////                        " and date_type = 'month'" +
////                        " and flow_status = 'finished'" +
////                        " and delete_type = '0'" +
////                        " and tenant_key='"+tenant_key+"' ";
//            String yearMonth = "";
//            if(i<10){
//                yearMonth = year+"-0"+i ;
//            }else{
//                yearMonth = year+"-"+i ;
//            }
//        }

        if(!dataMap.isEmpty()){
            String kpi_scheme = String.valueOf(dataMap.get("kpi_scheme"));

            log.error("kpi_scheme:"+kpi_scheme);

            if(StringUtils.isNotBlank(kpi_scheme)){
                String sql =" select indicator_type,indicator_description,weight \n" +
                        " from hr_kpi_scheme_indicator " +
                        " where scheme_id='"+kpi_scheme+"' " +
                        " and indicator_mode='quantify'\n" +
                        " and status='on' " +
                        " and delete_type = '0'" +
                        " and tenant_key = '"+tenant_key+"'" ;

                log.error("sql2:"+sql);
                Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);

                log.error("recordList:"+recordList.size());

                if(recordList.size()>=2){
                    for(int i=0;i<2;i++){
                        indicatorList.add(recordList.get(i));
                    }
                }else if(recordList.size() == 1){
                    indicatorList.add(recordList.get(0));

                    Map<String, Object> indicatorMap = new HashMap<String, Object>();
                    sql =   " select name,data_row,property\n" +
                            " from hr_kpi_details_link\n" +
                            " where kpi_details in( " +
                            "           select id\n" +
                            "           from hr_kpi_details " +
                            "           where KPI_SCHEME='"+kpi_scheme+"'\n" +
                            "           and MODULE='kpiSchemeSetting'\n" +
                            "           and TENANT_KEY='"+tenant_key+"'\n" +
                            "           and DELETE_TYPE = 0" +
                            "        )\n" +
                            "    and module = 'kpiSchemeSetting'\n" +
                            "    and tenant_key = '"+tenant_key+"'\n" +
                            "    and delete_type = '0'\n" +
                            "    and property in('weight', 'describe', 'type')\n" +
                            "    and data_row in ( \n" +
                            "        select p.data_row from (\n" +
                            "            select w.data_row from (\n" +
                            "                select data_row \n" +
                            "                from hr_kpi_details_link\n" +
                            "                where kpi_details in ( " +
                            "                       select id\n" +
                            "                       from hr_kpi_details " +
                            "                       where KPI_SCHEME='"+kpi_scheme+"'\n" +
                            "                       and MODULE='kpiSchemeSetting'\n" +
                            "                       and TENANT_KEY='"+tenant_key+"'\n" +
                            "                       and DELETE_TYPE = 0" +
                            "                 )\n" +
                            "                    and PROPERTY = 'weight'\n" +
                            "                    and MODULE = 'kpiSchemeSetting'\n" +
                            "                    and TENANT_KEY = '"+tenant_key+"'\n" +
                            "                    and DELETE_TYPE = '0'\n" +
                            "                    order by name desc\n" +
                            "            ) w limit 1 \n" +
                            "        ) p\n" +
                            "    )";
                    log.error("sql3:"+sql);
                    Map<String, Object> result2 = databaseUtils.execute(sourceType, groupId, sql);
                    List<Map<String,Object>> recordList2 = databaseUtils.getDataSourceList(result2);
                    log.error("recordList2:"+recordList2.size());
                    for(int i=0;i<recordList2.size();i++){
                        Map<String,Object> recordMap = recordList2.get(i);
                        String name = String.valueOf(recordMap.get("name"));
                        String property = String.valueOf(recordMap.get("property"));

                        log.error("name:"+name);
                        log.error("property:"+property);

                        if("weight".equalsIgnoreCase(property)){
                            indicatorMap.put("weight",name);
                        }
                        if("describe".equalsIgnoreCase(property)){
                            indicatorMap.put("indicator_description",name);
                        }
                        if("type".equalsIgnoreCase(property)){
                            indicatorMap.put("indicator_type",name);
                        }
                    }

                    if(!indicatorMap.isEmpty()){
                        indicatorList.add(indicatorMap);
                    }

                }else{

                    sql =   "  select w.data_row from (\n" +
                            "    select data_row\n" +
                            "    from hr_kpi_details_link\n" +
                            "    where kpi_details in( " +
                            "           select id\n" +
                            "           from hr_kpi_details " +
                            "           where KPI_SCHEME='"+kpi_scheme+"'\n" +
                            "           and MODULE='kpiSchemeSetting'\n" +
                            "           and TENANT_KEY='"+tenant_key+"'\n" +
                            "           and DELETE_TYPE = 0" +
                            "        )\n" +
                            "        and PROPERTY = 'weight'\n" +
                            "        and MODULE = 'kpiSchemeSetting'\n" +
                            "        and TENANT_KEY = '"+tenant_key+"'\n" +
                            "        and DELETE_TYPE = '0'\n" +
                            "    order by name desc\n" +
                            ") w  limit 2" ;
                    log.error("sql4:"+sql);
                    Map<String, Object> result3 = databaseUtils.execute(sourceType, groupId, sql);
                    List<Map<String,Object>> recordList3 = databaseUtils.getDataSourceList(result3);
                    for(int k=0;k<recordList3.size();k++){
                        Map<String,Object> recordMap3 = recordList3.get(k);

                        String data_row = String.valueOf(recordMap3.get("data_row"));

                        Map<String, Object> indicatorMap = new HashMap<String, Object>();

                        sql =   " select name,data_row,property\n" +
                                " from hr_kpi_details_link\n" +
                                " where kpi_details in( " +
                                "           select id\n" +
                                "           from hr_kpi_details " +
                                "           where KPI_SCHEME='"+kpi_scheme+"'\n" +
                                "           and MODULE='kpiSchemeSetting'\n" +
                                "           and TENANT_KEY='"+tenant_key+"'\n" +
                                "           and DELETE_TYPE = 0" +
                                "    )\n" +
                                "    and MODULE = 'kpiSchemeSetting'\n" +
                                "    and TENANT_KEY = '"+tenant_key+"'\n" +
                                "    and DELETE_TYPE = '0'\n" +
                                "    and property in('weight', 'describe', 'type')\n" +
                                "    and data_row in("+data_row+")" ;

                        log.error("sql5:"+sql);

                        Map<String, Object> result2 = databaseUtils.execute(sourceType, groupId, sql);
                        List<Map<String,Object>> recordList2 = databaseUtils.getDataSourceList(result2);

                        for(int i=0;i<recordList2.size();i++){

                            Map<String,Object> recordMap = recordList2.get(i);

                            String name = String.valueOf(recordMap.get("name"));
                            String property = String.valueOf(recordMap.get("property"));
                            if("weight".equalsIgnoreCase(property)){
                                indicatorMap.put("weight",name);
                            }
                            if("describe".equalsIgnoreCase(property)){
                                indicatorMap.put("indicator_description",name);
                            }
                            if("type".equalsIgnoreCase(property)){
                                indicatorMap.put("indicator_type",name);
                            }
                        }

                        indicatorList.add(indicatorMap);
                    }
                }
            }
            dataMap.put("indicator",indicatorList);
        }
        return dataMap ;
    }



    public List<Map<String, String>> getWholeYearKpi2(String employeeId,String groupId,String sourceType){

        List<Map<String, String>> dateList = new ArrayList<Map<String, String>>();

        Map<String, String> dataMap = null;
        LocalDate localDate = LocalDate.now();
        int year = localDate.getYear() ;
        int dayOfYear = 1 ;
        String[] monthzw = new String[]{"一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"};

        for(int i=1;i<=12;i++){
            Month month = Month.of(i);
            LocalDate startDay = YearMonth.of(year, month).atDay(dayOfYear); // 计算当前月份的首日
            LocalDate endDay = YearMonth.of(year, month).atEndOfMonth(); // 计算当前月份的最后一天

            log.error("getWholeYearKpi2-startDay:"+startDay);
            log.error("getWholeYearKpi2-endDay:"+endDay);

            String yearMonth = "";
            if(monthzw.length==12){
                yearMonth = monthzw[i-1];
            }

            String sql =" select score from hr_kpi_flow " +
                    " where kpi_user='"+employeeId+"' " +
                    " and left(real_period,10) >= '" +startDay+"'" +
                    " and left(real_period,10) <='" + endDay +"'" +
                    " and module = 'kpiFlow'" +
                    " and date_type = 'month'" +
                    " and flow_status in('noApprove','approve','finished') \n" +
                    " and delete_type = '0'" +
                    " and tenant_key='"+tenant_key+"' " ;

            log.error("getWholeYearKpi2-sql:"+sql);

            dataMap = new HashMap<String,String>();

            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(CollectionUtils.isNotEmpty(recordList)){
                Map<String,Object> recordMap = recordList.get(0);
                if(!recordMap.isEmpty()){
                    String score = String.valueOf(recordMap.get("score"));
                    if(StringUtils.isNotBlank(score)){
                        dataMap.put(yearMonth,score);
                    }
                }
            }else{
                dataMap.put(yearMonth,"0");
            }

            dateList.add(dataMap);
        }
        return dateList ;
    }


    public static String null2String(String s,String def) {
        return s == null ?(def==null?"":def) : s;
    }


    @GetMapping("/testSapi30")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi30(HttpServletRequest request){
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi30");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        try {

            String employeeId = request.getParameter("employeeId");
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }
            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            dataMap.put("employeeId",employeeId);
            dataMap.put("startday",startday);
            dataMap.put("endday",endday);

            String groupId = "weaver-ebuilder-form-service";
            String sourceType = "LOGIC";

            String sql =" select CONVERT(sum(cast(t1.htzje as decimal(18,2))),CHAR) as htzje," +
                        "        CONVERT(sum(cast(t1.htyxje as decimal(18,2))),CHAR) as htyxje," +
                        "        CONVERT(sum(cast(t1.sumsk as decimal(18,2))),CHAR) as sumsk " +
                        " from uf_jxhs_xmys t1 \n" +
                        " where t1.ysrq>='" +startday+"' and t1.ysrq<='"+endday+"' " +
                        " and ( t1.qyjl = '"+employeeId+"' "+
                        "       or t1.qyjl in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                        "       or t1.ysry = '"+employeeId+"'\n" +
                        "       or t1.ysry in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                        "       or t1.dqfzr = '"+employeeId+"'\n" +
                        "       or t1.dqfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                        "       or t1.tdjl = '"+employeeId+"'\n" +
                        "       or t1.tdjl in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                        "       or t1.tdfzr = '"+employeeId+"'\n" +
                        "       or t1.tdfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                        "       or t1.jgfzr = '"+employeeId+"'\n" +
                        "       or t1.jgfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"')\n" +
                        "       or t1.dqzj = '"+employeeId+"'\n" +
                        "       or t1.dqzj in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= '"+employeeId+"') " +
                        " ) " ;

            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            dataMap.put("datas",recordList);

        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi30:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }


    @GetMapping("/testSapi31")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi31(HttpServletRequest request){
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi31");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        try {

            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");
            String employeeId = request.getParameter("employeeId");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            dataMap.put("employeeId",employeeId);
            dataMap.put("startday",startday);
            dataMap.put("endday",endday);

            String groupId = "weaver-ebuilder-form-service";
            String sourceType = "LOGIC";

            String sql =" SELECT \n" +
                    "   CONVERT(sum(cast(t1.skje as decimal(18,2))),CHAR) as skje,\n" +  //收款金额
                    "   CONVERT(sum(cast(t1.xmskje as decimal(18,2))),CHAR) as xmskje,\n" + // 项目收款金额
                    "   CONVERT(sum(cast(t1.xsyxje as decimal(18,2))),CHAR) as xsyxje," + // 销售有效金额
                    "   CONVERT(sum(cast(t1.xsje as decimal(18,2))),CHAR) as xsje," + // 销售金额
                    "   CONVERT(sum(cast(t1.xmyxje as decimal(18,2))),CHAR) as xmyxje," + //项目有效金额
                    "   CONVERT(sum(cast(t1.xsjxhk as decimal(18,2))),CHAR) as xsjxhk," + //有效绩效回款
                    "   CONVERT(sum(cast(t1.sumsk as decimal(18,2))),CHAR) as sumsk," + //总收款金额
                    "   CONVERT(sum(cast(t1.sjjsk as decimal(18,2))),CHAR) as sjjsk," + //实际结算款
                    "   CONVERT(sum(cast(t1.skjs as decimal(18,2))),CHAR) as skjs " +  //收款结算
                    " FROM uf_jxhs_skmx t1\n" +
                    " LEFT JOIN uf_jxhs_zxhtzb t2 ON t1.hth = t2.hth AND t2.hth != '' AND t2.hth IS NOT NULL \n" +
                    " LEFT JOIN ebdf_physical_data epd on t1.id = epd.form_data_id  and epd.delete_type = 0 \n" +
                    " WHERE t1.skje != 0 \n" +
                    " and t1.skje IS NOT NULL " +
                    " and t1.xshsny >= '" + startday+"' and t1.xshsny <='"+endday+"' "+
                    " and (" +
                    "   '"+employeeId+"' IN ( 2, 27, 166, 10285, 11661, 300, 876, 3593, 1416, 1647, 1844,3044480226941419013,794508876297846787 ) \n" +
                    "   or cast(t1.xsjl AS decimal(25,0)) in( \n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid = '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    "   or cast(t1.kfry AS decimal(25,0)) in(\n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    "   or cast(t1.qdjl AS decimal(25,0)) in(\n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    "   or cast(t1.xmjl AS decimal(25,0)) in(\n" +
                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  '"+employeeId+"'  and RELATION in ('othersenior','senior') \n" +
                    "       UNION  " +
                    "       SELECT id FROM eteams.employee WHERE id =  '"+employeeId+"' " +
                    "   )\n" +
                    " )\n" +
                    " order by t1.id " ;

            log.error("sql:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            dataMap.put("datas",recordList);

        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi30:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }


    /**
     * 流程信息（我发起的）
     * @param request
     * @return
     */
    @GetMapping("/getWorkFlowInfo")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getWfInfoCreate(HttpServletRequest request){
        log.error("getWorkFlowInfo");

        List<RequestListInfoPAEntity> requestListInfoPAEntityList = new ArrayList<RequestListInfoPAEntity>();
        try{
            RequestListConditionApiEntity conditionEntity = new RequestListConditionApiEntity();
            SimpleEmployee employee = UserContext.getCurrentUser();
            String keyword = CommonUtils.null2String(request.getParameter("keyword"));
            if(!"".equals(keyword)){
                conditionEntity.setRequestname(keyword);
            }
            String type = CommonUtils.null2String(request.getParameter("type"),"0");
            int pageSize = CommonUtils.getIntValue(request.getParameter("pageSize"),10);
            int pageNo = CommonUtils.getIntValue(request.getParameter("pageNo"),1);
            // 0 我发起的； 1 我的待办； 2  我的已办
            if("0".equals(type)){
                WeaResult<List<RequestListInfoPAEntity>> requestResult = wflRequestListRest.getRequestListByTabId(employee, RequestListInitDimensionTabEnum.MINE_FLOWALL.getTabid(), pageNo, pageSize, conditionEntity);
                int code = requestResult.getCode();
                if(code == 200){
                    requestListInfoPAEntityList = requestResult.getData();
                }
            }else if("1".equals(type)){
                WeaResult<List<RequestListInfoPAEntity>> requestResult = wflRequestListRest.getRequestListByTabId(employee, RequestListInitDimensionTabEnum.TODO_FLOWALL.getTabid(), pageNo, pageSize, conditionEntity);

                int code = requestResult.getCode();
                if(code == 200){
                    requestListInfoPAEntityList = requestResult.getData();
                }

            }else if("2".equals(type)){
                WeaResult<List<RequestListInfoPAEntity>>  requestResult = wflRequestListRest.getRequestListByTabId(employee, RequestListInitDimensionTabEnum.DONE_FLOWALL.getTabid(), pageNo, pageSize, conditionEntity);

                int code = requestResult.getCode();
                if(code == 200){
                    requestListInfoPAEntityList = requestResult.getData();
                }
            }
        }catch (Exception e){
            log.error("getWorkFlowInfo-Exception:"+e.getMessage());
            return WeaResult.fail(500,"程序执行异常");
        }
        return WeaResult.success(requestListInfoPAEntityList);
    }


    @GetMapping("/getPortalWorkFlowInfo")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getPortalWorkFlowInfo(HttpServletRequest request){
        log.error("getPortalWorkFlowInfo");

        Map<String,Object> dataMap = new HashMap<String,Object>();
        try{
            RequestListConditionApiEntity conditionEntity = new RequestListConditionApiEntity();
            SimpleEmployee employee = UserContext.getCurrentUser();
            String keyword = CommonUtils.null2String(request.getParameter("keyword"));
            if(!"".equals(keyword)){
                conditionEntity.setRequestname(keyword);
            }
            int pageSize = CommonUtils.getIntValue(request.getParameter("pageSize"),10);
            int pageNo = CommonUtils.getIntValue(request.getParameter("pageNo"),1);
            // 0 我发起的； 1 我的待办； 2  我的已办

            WeaResult<List<RequestListInfoPAEntity>> requestResult0 = wflRequestListRest.getRequestListByTabId(employee, RequestListInitDimensionTabEnum.MINE_FLOWALL.getTabid(), pageNo, pageSize, conditionEntity);
            int code0 = requestResult0.getCode();
            if(code0 == 200){
                List<RequestListInfoPAEntity> requestList0 = requestResult0.getData();

                dataMap.put("PORTAL_MINE",requestList0);
            }

            WeaResult<List<RequestListInfoPAEntity>> requestResult1 =  wflRequestListRest.getRequestListByTabId(employee, RequestListInitDimensionTabEnum.TODO_FLOWALL.getTabid(), pageNo, pageSize, conditionEntity);
            int code1 = requestResult1.getCode();
            if(code1 == 200){
                List<RequestListInfoPAEntity>  requestList1 = requestResult1.getData();
                dataMap.put("TODO_FLOWALL",requestList1);
            }


            WeaResult<List<RequestListInfoPAEntity>>  requestResult2 =  wflRequestListRest.getRequestListByTabId(employee, RequestListInitDimensionTabEnum.DONE_FLOWALL.getTabid(), pageNo, pageSize, conditionEntity);
            int code2 = requestResult2.getCode();
            if(code2 == 200){
                List<RequestListInfoPAEntity> requestList2 = requestResult2.getData();
                dataMap.put("DONE_FLOWALL",requestList2);
            }
        }catch (Exception e){
            log.error("getWorkFlowInfo-Exception:"+e.getMessage());
            return WeaResult.fail(500,"程序执行异常");
        }
        return WeaResult.success(dataMap);
    }


//    @GetMapping("/testSapi50")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi50(HttpServletRequest request){
//        log.error("getPortalWorkFlowInfo");
//        int blogcount = 0 ;
//        try{
//            long employeeId = UserContext.getCurrentEmployeeId();
//            blogcount = remoteBlogInfoService.countByCreator(tenant_key,employeeId);
//        }catch (Exception e){
//            log.error("getWorkFlowInfo-Exception:"+e.getMessage());
//            return WeaResult.fail(500,"程序执行异常");
//        }
//        return WeaResult.success(blogcount);
//    }


    /***
     * 本年沟通协作数
     * @param request
     * @return
     */
    @GetMapping("/testSapi51")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi51(HttpServletRequest request){
        log.error("getPortalWorkFlowInfo");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

        String groupId = "weaver-cowork-service";
        String sourceType = "LOGIC";

        Map<String,Object> dataMap = new HashMap<String,Object>();
        try{
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");
            String employeeId = request.getParameter("employeeId");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            String sql = " select count(1) as cou from cw_content " +
                    " where  CREATOR='"+employeeId+"'\n" +
                    " and left(CREATE_TIME,10)>='"+startday+"' and left(CREATE_TIME,10) <= '"+endday+"'" ;

            log.error("sql:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(recordList.size()>0){
                dataMap = recordList.get(0);
            }

        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
            return WeaResult.fail(500,"程序执行异常");
        }
        return WeaResult.success(dataMap);
    }


    /***
     * 本年文档贡献度
     * @param request
     * @return
     */
    @GetMapping("/testSapi52")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi52(HttpServletRequest request){
        log.error("getPortalWorkFlowInfo");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

        String groupId = "weaver-doc-service";
        String sourceType = "LOGIC";


        Map<String,Object> dataMap = new HashMap<String,Object>();
        try{
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");
            String employeeId = request.getParameter("employeeId");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            String sql = " select count(1) as cou from document " +
                    " where CREATOR='"+employeeId+"'\n" +
                    " and left(create_time,10)>='"+startday+"' and left(create_time,10) <= '"+endday+"'" ;

            log.error("sql:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(recordList.size()>0){
                dataMap = recordList.get(0);
            }

        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
            return WeaResult.fail(500,"程序执行异常");
        }
        return WeaResult.success(dataMap);
    }


    /**
     * 本年处理流程数
     * @param request
     * @return
     */
    @GetMapping("/testSapi60")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi60(HttpServletRequest request){
        log.error("testSapi60");

        String startday = request.getParameter("startday");
        String endday = request.getParameter("endday");
        DateTimeFormatter format = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        Long count = 0L ;
        try{
            RequestListConditionApiEntity conditionEntity = new RequestListConditionApiEntity();
            SimpleEmployee employee = UserContext.getCurrentUser();
            LocalDateTime startDateTime = LocalDateTime.of(LocalDate.from(LocalDateTime.now().with(TemporalAdjusters.firstDayOfYear())), LocalTime.MIN);
            if(StringUtils.isNotBlank(startday)){
                startDateTime = LocalDateTime.parse(startday, format);
            }

            LocalDateTime endDateTime = LocalDateTime.now();
            if(StringUtils.isNotBlank(endday)){
                endDateTime = LocalDateTime.parse(endday, format);
            }
            conditionEntity.setCusOperateDateStart(startDateTime);
            conditionEntity.setCusOperateDateEnd(endDateTime);

            WeaResult<RequestCountInfoPAEntity>  RequestCountInfoPAEntity = wflRequestListRest.getRequestCountByTabId(employee, RequestListInitDimensionTabEnum.DONE_FLOWALL.getTabid(), conditionEntity);
            int code = RequestCountInfoPAEntity.getCode();
            if(code == 200){
                count = RequestCountInfoPAEntity.getData().getCount();
            }
        }catch (Exception e){
            log.error("getWorkFlowInfo-Exception:"+e.getMessage());
            return WeaResult.fail(500,"程序执行异常");
        }
        return WeaResult.success(count);
    }


    /***
     * 本年微博数量
     * @param request
     * @return
     */
    @GetMapping("/testSapi62")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi62(HttpServletRequest request){
        log.error("testSapi62");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

        String groupId = "weaver-blog-service";
        String sourceType = "LOGIC";


        Map<String,Object> dataMap = new HashMap<String,Object>();
        try{
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");
            String employeeId = request.getParameter("employeeId");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            String sql =" select count(1) as blogcount\n" +
                        "    from blog " +
                        "    where creator='"+employeeId+"'\n" +
                        "    and left(BLOG_TIME,10) >='"+startday+"'\n" +
                        "    and left(BLOG_TIME,10) <='"+endday+"'\n" +
                        "    and type='blog'\n" +
                        "    and TENANT_KEY = '"+tenant_key+"'\n" +
                        "    and MODULE = 'blog'\n" +
                        "    and DELETE_TYPE = 0\n" +
                        "    and CONTENT is not null" ;

            log.error("sql:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(recordList.size()>0){
                dataMap = recordList.get(0);
            }

        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
            return WeaResult.fail(500,"程序执行异常");
        }
        return WeaResult.success(dataMap);
    }


    /***
     * 本年开发人天
     * @param request
     * @return
     */
    @GetMapping("/testSapi70")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi70(HttpServletRequest request){

        log.error("testSapi70");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

        String groupId = "weaver-workflow-report-serviceworkflowreport";
        String sourceType = "LOGIC";


        Map<String,Object> dataMap = new HashMap<String,Object>();
        String devcou = "0" ;
        try{
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");
            String employeeId = request.getParameter("employeeId");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            if(StringUtils.isNotBlank(employeeId))
            {
                String dataSql =" select ifnull(sum(d.integer2),0) as devcou \n" +
                                " from wfc_form_data l\n" +
                                " inner join fto_62 d on d.id = l.dataid\n" +
                                " inner join wfc_requestbase p on p.requestid = l.requestid\n" +
                                " where d.multiresource5='"+employeeId+"'\n" +
                                " and d.date2 >='" + startday+"'"+
                                " and d.date2 <='" + endday+"'"+
                                " and d.tenant_key='"+tenant_key+"'\n" +
                                " and d.is_delete='0'\n" +
                                " and l.tenant_key='"+tenant_key+"'\n" +
                                " and l.delete_type=0\n" +
                                " and p.tenant_key='"+tenant_key+"'\n" +
                                " and p.delete_type=0\n" +
                                " order by d.id desc " ;

                log.info("dataSql:"+dataSql);

                Map<String, Object> result = databaseUtils.execute(sourceType, groupId, dataSql);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
                if(CollectionUtils.isNotEmpty(recordList)) {
                    devcou = String.valueOf(recordList.get(0).get("devcou"));
                }
            }

        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
            return WeaResult.fail(500,"程序执行异常");
        }
        return WeaResult.success(devcou);

    }



    /***
     * 本年开发人天
     * @param request
     * @return
     */
    @GetMapping("/testSapi71")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi71(HttpServletRequest request){

        log.error("testSapi71");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

        String groupId = "weaver-workflow-report-serviceworkflowreport";
        String sourceType = "LOGIC";

        Map<String,Object> dataMap = new HashMap<String,Object>();
        String devcou = "0" ;
        try{
            String startday = request.getParameter("startday");
            String endday = request.getParameter("endday");
            String employeeId = request.getParameter("employeeId");

            Calendar calendar = Calendar.getInstance();
            int year = calendar.get(Calendar.YEAR);

            if(StringUtils.isBlank(startday)){
                startday = year+"-01-01";
            }
            if(StringUtils.isBlank(endday)){
                endday = sdf.format(new Date());
            }

            if(StringUtils.isBlank(employeeId)){
                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
            }

            if(StringUtils.isNotBlank(employeeId))
            {
                String dataSql =" select count(1) as devcou \n" +
                                " from wfc_form_data l\n" +
                                " inner join fto_83 d on d.id = l.dataid\n" +
                                " inner join wfc_requestbase p on p.requestid = l.requestid\n" +
                                " where d.mutiresource='"+employeeId+"'\n" +
                                " and d.xsjfrq >='" + startday+"'"+
                                " and d.xsjfrq <='" + endday+"'"+
                                " and d.tenant_key='"+tenant_key+"'\n" +
                                " and d.is_delete='0'\n" +
                                " and l.tenant_key='"+tenant_key+"'\n" +
                                " and l.delete_type=0\n" +
                                " and p.tenant_key='"+tenant_key+"'\n" +
                                " and p.delete_type=0\n" +
                                " order by d.id desc " ;

                log.info("dataSql:"+dataSql);

                Map<String, Object> result = databaseUtils.execute(sourceType, groupId, dataSql);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
                if(CollectionUtils.isNotEmpty(recordList)) {
                    devcou = String.valueOf(recordList.get(0).get("devcou"));
                }
            }

        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
            return WeaResult.fail(500,"程序执行异常");
        }
        return WeaResult.success(devcou);

    }






}
