package com.weaver.seconddev.jcldoor.service.impl;


import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.seconddev.jcldoor.cmd.*;
import com.weaver.seconddev.jcldoor.service.JucailinPortalService;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.workflow.common.entity.list.api.publicapi.RequestListInfoPAEntity;
import groovy.util.logging.Slf4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import javax.sound.sampled.Port;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;


@Slf4j
@Service
public class JucailinPortalServiceImpl implements JucailinPortalService {

    private final Logger log = LoggerFactory.getLogger(JucailinPortalServiceImpl.class);

    @Autowired
    private UserInfoCmd userInfoCmd;

    @Autowired
    private PortalBirthdayWishesCmd portalBirthdayWishesCmd;

    @Autowired
    private PortalPerformanceInfoCmd portalPerformanceInfoCmd;

    @Autowired
    private PortalRiskInfoCmd portalRiskInfoCmd;

    @Autowired
    private PortalInteractCountCmd portalInteractCountCmd;

    @Autowired
    private PortalDocCreateCountCmd portalDocCreateCountCmd;

    @Autowired
    private PortalWfDealCountCmd portalWfDealCountCmd;

    @Autowired
    private PortalDailyCountCmd portalDailyCountCmd;

    @Autowired
    private PortalCollaborationInfoCmd portalCollaborationInfoCmd;

    @Autowired
    private ProjectAcceptanceInfoCmd projectAcceptanceInfoCmd;

    @Autowired
    private ProjectReceiptsInfoCmd projectReceiptsInfoCmd;

    @Autowired
    private ProjectCollaborationInfoCmd projectCollaborationInfoCmd;

    @Autowired
    private DevDaysCountCmd devDaysCountCmd;

    @Autowired
    private DevQuestCountCmd devQuestCountCmd;

    @Autowired
    private DevCollaborationInfoCmd devCollaborationInfoCmd;




    @Override
    public Map<String, Object> getPortalUserData(SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = userInfoCmd.getUserInfo(simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getPortalAttendanceData(SimpleEmployee simpleEmployee) {

        Map<String,Object> dataMap = new HashMap<String,Object>();

        String zjkqnj = "0.00";
        String lnkqnj = "0.00";
        String jnkqnj = "0.00";

        String ycqts = "0.00";
        String wcts = "0.00" ;
        double xjts = 0.00;
        int cdsc = 0;
        int qkcs = 0;
        String ydkcs = "0.00";
        dataMap.put("zjkqnj",zjkqnj);    //总计可请年假
        dataMap.put("lnkqnj",lnkqnj);    //历年可请年假
        dataMap.put("jnkqnj",jnkqnj);    //今年可请年假
        dataMap.put("wcts",wcts);   //外出天数
        dataMap.put("xjts",xjts);   //休假天数
        dataMap.put("cdsc",cdsc);  //迟到次数
        dataMap.put("qkcs",qkcs);  // 缺卡次数
        dataMap.put("ydkcs",ydkcs);  //已打卡次数
        dataMap.put("ycqts",ycqts); //应出勤天数
        dataMap.put("employeeid",simpleEmployee.getEmployeeId()); //应出勤天数

        return dataMap;
    }

    @Override
    public Map<String, Object> getPortalPerformanceData(SimpleEmployee simpleEmployee) {

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String type = "";
        String year = "2024";
        String month = "02";

        String startdate = "";
        String enddate = "";
        int currentYear = 0 ;
        int currentMonth = 0;
        int lastYear = 0;
        int lastMonth = 0 ;
        int last2Year = 0;
        int last2Month = 0 ;
        if("1".equals(type)){

            try {
                Calendar cal = Calendar.getInstance();
                cal.setTime(sdf.parse(year+"-"+month+"-01"));
                currentYear = cal.get(Calendar.YEAR);//获取年
                currentMonth = cal.get(Calendar.MONTH)+1;//获取月（月份从0开始，如果按照中国的习惯，需要加一）
            } catch (ParseException e) {
                e.printStackTrace();
            }

            try {
                Calendar cal = Calendar.getInstance();
                cal.setTime(sdf.parse(year+"-"+month+"-01"));
                cal.add(Calendar.MONTH, -1);
                lastYear = cal.get(Calendar.YEAR);//获取年
                lastMonth = cal.get(Calendar.MONTH)+1;//获取月（月份从0开始，如果按照中国的习惯，需要加一）
            } catch (ParseException e) {
                e.printStackTrace();
            }

            try {
                Calendar cal = Calendar.getInstance();
                cal.setTime(sdf.parse(year+"-"+month+"-01"));
                cal.add(Calendar.MONTH, -2);
                last2Year = cal.get(Calendar.YEAR);//获取年
                last2Month = cal.get(Calendar.MONTH)+1;//获取月（月份从0开始，如果按照中国的习惯，需要加一）
            } catch (ParseException e) {
                e.printStackTrace();
            }

            if(currentMonth == 1){
                startdate = (currentYear-1)+"-01-01";
                enddate = (currentYear-1)+"-12-31";
            }else{
                startdate = currentYear+"-01-01";
                enddate = currentYear+"-12-31";
            }

        }else{

            Calendar cal1 = Calendar.getInstance();
            currentYear = cal1.get(Calendar.YEAR);//获取年
            currentMonth = cal1.get(Calendar.MONTH)+1;//获取月（月份从0开始，如果按照中国的习惯，需要加一）


            Calendar cal2 = Calendar.getInstance();
            cal2.setTime(new Date());
            cal2.add(Calendar.MONTH, -1);
            lastYear = cal2.get(Calendar.YEAR);//获取年
            lastMonth = cal2.get(Calendar.MONTH)+1;//获取月（月份从0开始，如果按照中国的习惯，需要加一）


            Calendar cal3 = Calendar.getInstance();
            cal3.setTime(new Date());
            cal3.add(Calendar.MONTH, -2);
            last2Year = cal3.get(Calendar.YEAR);//获取年
            last2Month = cal3.get(Calendar.MONTH)+1;//获取月（月份从0开始，如果按照中国的习惯，需要加一）

            if(currentMonth == 1){
                startdate = (currentYear-1)+"-01-01";
                enddate = (currentYear-1)+"-12-31";
            }else{
                startdate = currentYear+"-01-01";
                enddate = currentYear+"-12-31";
            }
        }

        Long userid = simpleEmployee.getEmployeeId();
        List<String> monthList = new ArrayList<String>();
        List<Map<String,String>> data = new ArrayList<Map<String,String>>();
        List<Map<String,String>> item = new ArrayList<Map<String,String>>();
        Map<String,String> lastscop = new HashMap<String,String>();
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("scoreData",data);
        dataMap.put("scoreYear",currentYear);
        dataMap.put("itemData",item);
        dataMap.put("lastScoreData",lastscop);
        dataMap.put("startdate",startdate);
        dataMap.put("enddate",enddate);
        dataMap.put("userid",userid);

        return dataMap;
    }


    @Override
    public Map<String, Object> getPortalBirthdayWishes(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = portalBirthdayWishesCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getPortalRiskInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = portalRiskInfoCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getPortalPerformanceInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = portalPerformanceInfoCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getPortalInteractCount(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = portalInteractCountCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getPortalDocCreateCount(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = portalDocCreateCountCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getPortalWfDealCount(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = portalWfDealCountCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getPortalDailyCount(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = portalDailyCountCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getPortalCollaborationInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = portalCollaborationInfoCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getProjectAcceptanceInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = projectAcceptanceInfoCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getProjectReceiptsInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = projectReceiptsInfoCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getProjectCollaborationInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = projectCollaborationInfoCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getDevQuestCount(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = devQuestCountCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getDevDaysCount(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = devDaysCountCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

    @Override
    public Map<String, Object> getDevCollaborationInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> dataMap = devCollaborationInfoCmd.getInfo(request,simpleEmployee);
        return dataMap;
    }

}
